-- $Name: Башня-60$
-- $Version: 0.8.3$
-- $Author: Cavemen ProgrammerZ$

instead_version "1.5.0"

require "format"
require "hideinv"
require "nouse"
require "timer"

game.codepage = "UTF-8";

format.para = true;
format.dash = true;
format.quotes = true;

global {
	_last_quest = 0;
};

function init ()
	take(sp_freeze);
	take(sp_anim);
	take(sp_light);
	take(sp_tele);
	take(sp_zap);
	lifeon('sp_tele');
	lifeon('sp_anim');
end

function mix(col)
	if mixture._flavor == 0 then
		if mixture._essence == 0 then
			if mixture._base == 0 then
				if not disabled(flask) then
					flask:disable();
					mixture:enable();
					lifeon('mixture');
					mixture._base = col;
					return 'Я добавляю в зелье основной элемент.';
				else
					return 'Мне не в чем смешивать зелье!';
				end
			else
				mixture._essence = col;
				return 'Я добавляю в зелье эссенцию. Для самых простых зелий этого уже достаточно.';
			end
		else
			mixture._flavor = col;
			if alchemy._riddle == 1 then
				if mixture._base == 1 and mixture._essence == 5 and mixture._flavor == 7 then
					set_sound('snd/success.ogg');
					mixture._success = true;
				end
			elseif alchemy._riddle == 2 then
				if mixture._base == 3 and mixture._essence == 4 and mixture._flavor == 1 then
					set_sound('snd/success.ogg');
					mixture._success = true;
				end
			elseif alchemy._riddle == 3 then
				if mixture._base == 2 and mixture._essence == 6 and mixture._flavor == 5 then
					set_sound('snd/success.ogg');
					mixture._success = true;
				end
			elseif alchemy._riddle == 4 then
				if mixture._base == 4 and mixture._essence == 2 and mixture._flavor == 3 then
					set_sound('snd/success.ogg');
					mixture._success = true;
				end
			end
			return 'Я добавляю каплю последнего элемента, и зелье можно считать практически готовым. Осталось запустить реакцию.';
		end
	else
		return 'Если продолжить добавлять в зелье дополнительные элементы, то результат может оказаться печальным.';
	end
end

function quest(num)
	local n = rnd(5)
	while (n == num) or (n == _last_quest) do
		n = rnd(5);
	end
	_last_quest = n;
	if n == 1 then
		walk('question_a');
		return true;
	elseif n == 2 then
		walk('question_b');
		return true;
	elseif n == 3 then
		walk('question_c');
		return true;
	elseif n == 4 then
		walk('question_d');
		return true;
	elseif n == 5 then
		walk('question_e');
		return true;
	end
end

sp_freeze = obj {
	isspell = true,
	nam = 'Заморозка',
	disp = img('gfx/freeze.png'),
	inv = 'Я выдыхаю на ладонь, и она покрывается инеем.',
	use = function (s,w)
		if w.isspell then
			return 'Смешивать чары самостоятельно, без наставника - опасное занятие!';
		end
	end,
	nouse = 'Не думаю, что это нуждается в заморозке.',
}

sp_anim = obj {
	isspell = true,
	_state = nil,
	_active = 0,
	nam = 'Оживление',
	var { disp = img('gfx/animate.png') };
	inv = 'Я хлопаю в ладоши, и камушек из-под моего сапога убегает в неизвестном направлении.',
	use = function (s,w)
		if w.isspell then
			return 'Смешивать чары самостоятельно, без наставника - опасное занятие!';
		end
	end,
	nouse = function (s)
		if s._state == nil then
			return 'И где мне потом это ловить?';
		elseif s._state == 'vine' then
			return 'Плеть туда просто не дотянется.';
		elseif s._state == 'armor' then
			if armor._chained then
				if disabled(chain) then
					chain:enable();
				end
				return 'Латы пытаются сделать шаг, но цепь надежно удерживает их на месте.';
			else
				return 'Латы бодро шагают в указанную сторону, но сделать ничего не могут.';
			end
		elseif s._state == 'oven' then
			return 'Печь лишь тяжело вздыхает.';
		elseif s._state == 'rope' then
			return 'Петля раскачивается и извивается, но дотянуться не может.';
		elseif s._state == 'key' then
			return 'Я пытаюсь направить ключ туда, но он снова и снова возвращается к потолочной лампе.';
		end
	end,
	life = function (s)
		if s._state == 'vine' then
			s._active = s._active + 1;
			if s._active <= 3 then
				s.disp = img('gfx/anim_vine.png');
				add_sound('snd/vines.ogg');
				p 'Я чувствую, как плеть пытается вырваться из-под моего контроля.';
			else
				s._state = nil;
				s.disp = img('gfx/animate.png');
				return 'Плеть мне больше не подчиняется. Из глубины зарослей доносится натужное сопение.';
			end
		elseif s._state == 'armor' then
			s._active = s._active + 1;
			if s._active <= 3 then
				s.disp = img('gfx/anim_arm.png');
				add_sound('snd/armor.ogg');
				p 'Каждый звук гулко отдается в голове, как будто на нее напялили металлическое ведро.';
			else
				s._state = nil;
				s.disp = img('gfx/animate.png');
				return 'Доспехи замирают посреди комнаты, безвольно опустив металлические руки.';
			end
		elseif s._state == 'oven' then
			s._active = s._active + 1;
			if s._active <= 3 then
				s.disp = img('gfx/anim_oven.png');
				add_sound('snd/oven.ogg');
				p 'Моя голова тяжелеет и становится будто чугунной; отчего-то вдруг клонит в сон.';
			else
				s._state = nil;
				s.disp = img('gfx/animate.png');
				return 'Я слышу протяжный зевок. Печь, видимо, решила вернуться ко сну.';
			end
		elseif s._state == 'rope' then
			s._active = s._active + 1;
			if s._active <= 3 then
				s.disp = img('gfx/anim_rope.png');
				add_sound('snd/vines.ogg');
				p 'Петля хищно тянется ко мне, но дотянуться не может.';
			else
				s._state = nil;
				s.disp = img('gfx/animate.png');
				return 'Веревка безвольно повисает и развязывается.';
			end
		elseif s._state == 'key' then
			s._active = s._active + 1;
			if s._active <= 3 then
				s.disp = img('gfx/anim_key.png');
				add_sound('snd/wings.ogg');
				p 'Ключ отчаянно бьет крыльями, пытаясь вырваться на свободу.';
			else
				s._state = nil;
				s.disp = img('gfx/animate.png');
				return 'Ключ снова устремляется к лампе на потолке.';
			end
		else
			s.disp = img('gfx/animate.png');
		end
	end,
}

sp_light = obj {
	isspell = true,
	nam = 'Свет',
	disp = img('gfx/light.png'),
	inv = 'Взмах рукой, и вокруг становится будто бы светлее.',
	use = function (s,w)
		if w.isspell then
			return 'Смешивать чары самостоятельно, без наставника - опасное занятие!';
		end
	end,
	nouse = 'Ничего нового я при волшебном свете здесь не увижу.',
}

sp_tele = obj {
	isspell = true,
	_state = nil,
	nam = 'Телекинез',
	var { disp = img('gfx/telekinesis.png') };
	inv = 'Я подбрасываю монетку, и она зависает в воздухе.',
	use = function (s,w)
		if w.isspell then
			return 'Смешивать чары самостоятельно, без наставника - опасное занятие!';
		end
	end,
	nouse = function (s)
		if s._state == nil then
			return 'Не вижу нужды напрягаться ради этого.';
		elseif s._state == 'lamp' then
			return 'Не думаю, что здесь нужен фонарь.';
		elseif s._state == 'flask' then
			return 'Не надо ее сюда ставить. Еще, чего доброго, разобьется.';
		elseif s._state == 'book' then
			return 'Не самое подходящее место для книги.';
		elseif s._state == 'hat' then
			return 'Пожалуй, не стоит накрывать это шляпой.';
		else
			return 'Пожалуй, это не самое подобающее место для обеда.';
		end
	end,
	life = function (s)
		if s._state == 'lamp' then
			s.disp = img('gfx/tele_lamp.png');
			p 'Рядом со мной в воздухе болтается старомодный фонарь.';
		elseif s._state == 'flask' then
			s.disp = img('gfx/tele_flask.png');
			p 'Я аккуратно поддерживаю в воздухе алхимическую колбу.';
		elseif s._state == 'book' then
			s.disp = img('gfx/tele_book.png');
			p 'Над моей головой парит увесистый том.';
		elseif s._state == 'cup' then
			s.disp = img('gfx/tele_cup.png');
			p 'Я поддерживаю в воздухе чашку.';
		elseif s._state == 'plate' then
			s.disp = img('gfx/tele_plate.png');
			p 'Я удерживаю в воздухе тарелку.';
		elseif s._state == 'pot' then
			s.disp = img('gfx/tele_pot.png');
			p 'Рядом со мной парит кастрюля.';
		elseif s._state == 'tray' then
			s.disp = img('gfx/tele_tray.png');
			p 'Передо мной висит серебряный поднос.';
		elseif s._state == 'hat' then
			s.disp = img('gfx/tele_hat.png');
			p 'Надо мной порхает старая пыльная шляпа.';
		else
			s.disp = img('gfx/telekinesis.png');
		end
	end,
}

sp_zap = obj {
	isspell = true,
	nam = 'Разряд',
	disp = img('gfx/zap.png'),
	inv = 'Щелчок пальцами, и вокруг меня рассыпаются разноцветные искры.',
	use = function (s,w)
		if w.isspell then
			return 'Смешивать чары самостоятельно, без наставника - опасное занятие!';
		end
	end,
	nouse = 'Стремление к разрушению -- порок.',
}

sp_quit = obj {
	isspell = true,
	nam = 'Выход',
	disp = img('gfx/quit.png'),
	inv = function (s)
		if me().where == 'attic' then
			set_sound('snd/whisper.ogg');
			lifeoff(s);
			walk('nothing');
			return true;
		elseif me().where == 'nothing' then
			set_sound('snd/whisper.ogg');
			bigchain:disable();
			bigstone:disable();
			biglamp:disable();
			bigdoor._opened = false;
			ways('nothing')[1]:disable();
			bigdoor:disable();
			bigvine:enable();
			nothing.pic = 'gfx/nothing0.png';
			walk('nothing');
			return true;
		end
	end,
	use = function (s,w)
		if w.isspell then
			return 'Смешивать чары самостоятельно, без наставника - опасное занятие!';
		end
	end,
	nouse = 'С незнакомыми заклинаниями надо быть аккуратнее.',
	life = function ()
		add_sound('snd/whisper.ogg');
		return 'В голове,  настойчиво пытаясь произнестись, мечется незнакомое слово.';
	end,
}

main = room {
	hideinv = true,
	nam = 'Начало',
	disp = '* * *',
	dsc = [[
		Тридцать девять... Да уж, с непривычки идти в гору трудновато. Как знал, надо было захватить на учебу метлу...
		^^Сорок шесть... А все из-за этого дубины Фальстафа! Кто еще мог наябедничать наставнику, что это я превратил все его запонки в лягушек?
		^^Пятьдесят восемь... У наставника с чувством юмора неважно. Впрочем, едва ли стоит ожидать благостного расположения духа от того, кто был вынужден скакать на четвереньках по аудитории на глазах у всех учеников.
		^^Двадцать пять... Двадцать пять?! Да кто придумал эту дурацкую нумерацию? А еще Великие магистры...
	]],
	obj = { vway('next', '{^Дальше...}', 'title') },
	entered = function()
		set_music('mus/intro.ogg');
	end,
}

title = room {
	hideinv = true,
	nam = 'Башня-60',
	pic = 'gfx/tower60.png',
	dsc = [[
		Вот она, наконец: Башня шестьдесят. Наставник оставил ее лет пять назад, когда появилась возможность перебраться в башню повыше. А мне теперь искать его трубку!..
	]],
	obj = { vway('start', txtc(txtb('{^Начать}')), 'outside') },
}

--outside

outside = room {
	nam = 'У входа в Башню',
	var { pic = 'gfx/outside0.png' },
	dsc = [[
		Сразу видно, что в башне давно никто не бывал. Когда-то белая краска облупилась, обнажив кирпичную кладку.
	]],
	obj = { 'threshold', 'lamp_post', 'lamp1', 'shrub', 'lamp2', 'vines', 'entrance' },
	way = { vroom('Внутрь', 'foyer'):disable() },
	entered = function()
		set_music('mus/outside.ogg');
		return 'Смеркается. А потом в кромешной темноте еще возвращаться в общежитие. Ну, Фальстаф...';
	end,
	exit = function ()
		sp_anim._state = nil;
		return true;
	end,
}

threshold = obj {
	nam = 'навес',
	dsc = '{Навес} от неухоженности сильно проржавел.',
	act = function()
		if not entrance._revealed then
			if lamp1._lit or lamp_post._lit then
				return 'Я пытаюсь поддеть дверь, но она как будто нарисована. Здесь явно не обошлось без чар!';
			else
				return 'Я тщательно ощупываю стену под навесом на предмет скрытых переключателей, но безуспешно.';
			end
		else
			if not entrance._opened then
				return 'Вот она, входная дверь -- во плоти, так сказать. Достаточно всего лишь открыть ее, дело за малым.';
			else
				return 'Внутри башни вроде бы горит свет и довольно уютно. Если это не еще одна иллюзия, конечно.';
			end
		end
	end,
	used = function (s,w)
		if w == sp_light then
			if not entrance._revealed then
				if lamp1._lit or lamp_post._lit then
					return 'Я подхожу поближе к нарисованной двери, и под воздействием волшебного света проступает ручка... Увы, моих сил недостаточно, чтобы развеять чары на входе целиком.';
				else
					return 'Я направляю волшебный свет на пространство под навесом, и вижу проступающие очертания входной двери. Интересно... Но мне нужен постоянный источник света.';
				end
			else
				return 'Вот она, входная дверь -- во плоти, так сказать. Я могу дотронуться до нее и руками.';
			end
		end
	end,
}

lamp_post = obj {
	_placed = false,
	_lit = false,
	nam = 'место под фонарь',
	dsc = function (s)
		if not s._placed then
			p 'Один из штырей под навесом {пуст},';
		else
			p '{Фонарь} снова занял свое законное место под навесом,';
		end	
	end,
	act = function (s)
		if not s._placed then
			return 'Врожденное чувство симметрии подсказывает мне, что здесь должно что-то висеть.';
		else
			if not s._lit then
				return 'Фонарь не горит. Я легонько толкаю его, и он со скрипом раскачивается.';
			else
				return 'Свет фонаря разгоняет волшебный сумрак. Я знал, что здесь не все так просто!';
			end
		end
	end,
	used = function (s,w)
		if w == sp_light then
			if s._placed then
				if not s._lit then
					s._lit = true;
					if not lamp1._lit then
						set_sound('snd/light.ogg');
						here().pic = 'gfx/outside4.png';
						return 'Несколько пассов руками, и свечка внутри фонаря загорается тусклым светом... М-да, усталость - не шутка. Обычно получается гораздо ярче.';
					else
						set_sound('snd/light.ogg');
						here().pic = 'gfx/outside5.png';
						entrance._revealed = true;
						return 'Теперь очередь второго фонаря. Несколько пассов, и он тоже зажигается... Вместе силы двух огней хватает, чтобы развеять чары на двери!';
					end
				else
					if not entrance._revealed then
						return 'Я повторяю заклинание, но света больше не становится. Видимо, дело в свече или самом фонаре.';
					else
						return 'Два фонаря светят достаточно ярко, чтобы развеять чары на двери. Незачем тратить ценные силы.';
					end
				end
			end
		elseif w == sp_tele and sp_tele._state == 'lamp' then
			sp_tele._state = nil;
			s._placed = true;
			set_sound('snd/telek.ogg');
			if not lamp1._lit then
				here().pic = 'gfx/outside1.png';
			else
				here().pic = 'gfx/outside3.png';
			end
			return 'Аккуратно поддерживая фонарь в воздухе двумя руками, я водружаю его на законное место.';
		end
	end,

}

lamp1 = obj {
	_lit = false,
	nam = 'правый фонарь',
	dsc = function ()
		if not lamp_post._placed then
			p 'а на другом болтается старомодный {фонарь}.';
		else
			p 'и теперь они болтаются на пару со старомодным {соседом}.';
		end
	end,
	act = function(s)
		if not s._lit then
			return 'Фонарь не горит. Я легонько толкаю его, и он со скрипом раскачивается.';
		else
			return 'Свет фонаря разгоняет волшебный сумрак. Я знал, что здесь не все так просто!';
		end
	end,
	used = function (s,w)
		if w == sp_light then
			if not s._lit then
				s._lit = true;
				if not lamp_post._lit then
					set_sound('snd/light.ogg');
					if not lamp_post._placed then
						here().pic = 'gfx/outside2.png';
					else
						here().pic = 'gfx/outside3.png';
					end
					return 'Несколько пассов руками, и свечка внутри фонаря загорается тусклым светом... М-да, усталость - не шутки. Обычно получается гораздо ярче.';
				else
					set_sound('snd/light.ogg');
					here().pic = 'gfx/outside5.png';
					entrance._revealed = true;
					return 'Теперь очередь второго фонаря. Несколько пассов, и он тоже зажигается... Вместе силы двух огней хватает, чтобы развеять чары на двери!';
				end
			else
				if not entrance._revealed then
					return 'Я повторяю заклинание, но света больше не становится. Видимо, дело в свече или самом фонаре.';
				else
					return 'Два фонаря светят достаточно ярко, чтобы развеять чары на двери. Незачем тратить ценные силы.';
				end
			end
		end
	end,
}

shrub = obj {
	nam = 'заросли',
	dsc = 'Когда-то аккуратно подстриженный {кустарник}, уже несколько лет не знавший садовника, разросся до безобразия.',	act = function()
		if disabled(lamp2) then
			lamp2:enable();
			return 'Осторожно, чтобы не порвать мантию -- подарок от крестного! -- я раздвигаю ветки... Там что-то есть!';
		else
			return 'Больше ничего интересного в кустах нет. Или просто не видно.';
		end
	end,
	used = function (s,w)
		if w == sp_freeze then
			if seen (vines) then
				sp_anim._state = nil;
				remove(s);
				set_sound('snd/freeze.ogg');
				return 'От резкого понижения температуры плеть сморщивается и скрючивается, отцепляясь от фонаря!.. Из зарослей доносится обиженный вздох.';
			end
		elseif w == sp_anim and sp_anim._state == 'vine' then
			vines:disable();
			sp_anim._state = nil;
			set_sound('snd/animate.ogg');
			return 'Усилием воли я все же заставляю плеть убраться восвояси, но, учитывая ее упорство, боюсь, этого ненадолго хватит.';
		elseif w == sp_light then
			if disabled(lamp2) then
				lamp2:enable();
				set_sound('snd/light.ogg');
				return 'Я разгоняю темноту вокруг кустов, и вижу, что на земле что-то блестит!';
			else
				return 'Даже волшебный свет не помогает заглянуть внутрь этих зарослей.';
			end
		elseif w == sp_tele and sp_tele._state == nil then
			if disabled(lamp2) then
				lamp2:enable();
				set_sound('snd/telek.ogg');
				return 'И правда, зачем рисковать мантией -- подарком от крестного? Взмах рукой -- и ветки раздвигаются сами собой... В зарослях что-то есть!';
			else
				return 'Я еще поворошил кусты, но в конце концов мне это надоело.';
			end		
		elseif w == sp_zap then
			if seen (vines) then
				return 'Правило 5, пункт 3, параграф И Кодекса гласит, что неизвестные виды подлежат изучению, и за любой нанесенный им вред полагается строгая кара... Меня, конечно, никто не видит, но мало ли?';
			end
		end
	end,
}

lamp2 = obj {
	nam = 'второй фонарь',
	dsc = 'Среди зарослей тускло поблескивает металлический корпус еще одного {фонаря}!',
	act = function (s)
		p 'Увесистая, должно быть, штуковина! Думаю, я знаю, где ему самое место...';
		if disabled(vines) then
			set_sound('snd/vines.ogg');
			vines:enable();
			p 'Однако стоило мне подойти к фонарю, как вокруг него обвивается опасного вида колючая плеть!';
		else
			if seen (vines) then
				p 'Вот только его удерживает некое злонамеренное растение!';
			end
		end
	end,
	used = function (s,w)
		if w == sp_anim and sp_anim._state == 'vine' then
			return 'Но плеть и так удерживает фонарь!';
		elseif w == sp_light then
			return 'Увы, пока он лежит на земле, толку от его света будет мало.';
		elseif w == sp_tele and sp_tele._state == nil then
			if not seen (vines) then
				sp_tele._state = 'lamp';
				remove(s);
				set_sound('snd/telek.ogg');
				return 'Я жестом приказываю фонарю подняться с земли, и он медленно плывет ко мне. Вопреки расхожему мнению, при использовании телекинеза волшебник частично ощущает вес предмета. Надо куда-то его пристроить.';
			else
				return 'Я жестом приказываю фонарю подняться с земли, но колючки вцепились в него и не отпускают!..';
			end
		elseif w == sp_zap then
			if seen (vines) then
				sp_anim._state = nil;
				vines:disable();
				set_sound('snd/zap.ogg');
				return 'Кодекс весьма строг в отношении неизвестных видов, но про неодушевленные предметы там ничего не сказано. Я посылаю несильный разряд в металлическую часть фонаря, и колючее щупальце отдергивается! В кустах кто-то обиженно рычит...';
			end
		end
	end,
}:disable();

vines = obj {
	nam = 'колючки',
	dsc = 'Вокруг него обвилась колючая {плеть} какого-то непонятного растения!',
	act = 'Подобные, хм, создания обычно появляются из-за вредной привычки волшебников выплескивать неудавшиеся зелья за окно. Лучше с ним не связываться.',
	used = function (s,w)
		if w == sp_freeze then
			sp_anim._state = nil;
			remove(s);
			set_sound('snd/freeze.ogg');
			return 'От резкого понижения температуры плеть сморщивается и скрючивается, отцепляясь от фонаря!.. Из зарослей доносится обиженный вздох.';
		elseif w == sp_anim then
			if sp_anim.state == nil then
				sp_anim._state = 'vine';
				sp_anim._active = 0;
				set_sound('snd/animate.ogg');
				return 'Усилием воли я заставляю плеть повиноваться себе, но у нее, оказывается, есть зачатки разума!.. Совладать с ней будет непросто.';
			else
				return '\"ПЩ-Щ-Щ!\"';
			end
		elseif w == sp_light then
			return 'Как правило, подобные явления оказываются разного рода иллюзиями, которые можно рассеять волшебным светом... Но нет, передо мной действительно какое-то неизвестное в природе растение.';
		elseif w == sp_tele and sp_tele._state == nil then
			return 'Увы, упорством и силой мы с растением равны... Хорошо, что меня никто не видит. Засмеяли бы.';
		elseif w == sp_zap then
			return 'Правило 5, пункт 3, параграф И Кодекса гласит, что неизвестные виды подлежат изучению, и за любой нанесенный им вред полагается строгая кара... Меня, конечно, никто не видит, но мало ли?';
		end
	end,
}:disable();

entrance = obj {
	_opened = false,
	_revealed = false,
	nam = 'вход',
	dsc = function (s)
		if not s._revealed then
			if lamp1._lit or lamp_post._lit then
				p 'В тусклом свете фонаря проглядывают смутные очертания чего-то, похожего на {дверь}.';
			else
				p 'Какого-либо подобия входной двери, как ни странно, не наблюдается.';
			end
		else
			p 'Прямо под навесом, освещенная магическим светом, появилась {дверь}!';
		end
	end,
	act = function (s)
		if not s._revealed then
			return 'Я пытаюсь поддеть дверь, но она как будто нарисована. Здесь явно не обошлось без чар!';
		else
			if not s._opened then
				s._opened = true;
				ways()[1]:enable();
				set_sound('snd/success.ogg');
				return 'Стоит мне протянуть руку, как дверь гостеприимно распахивается';
			else
				return 'Внутри башни вроде бы горит свет и довольно уютно. Если это не еще одна иллюзия, конечно.';
			end
		end
	end,
	used = function (s,w)
		if w == sp_light then
			if not s._revealed then
				return 'Я подхожу поближе к нарисованной двери, и под воздействием волшебного света проступает ручка... Увы, моих сил недостаточно, чтобы развеять чары на входе целиком.';
			else
				return 'Вот она, входная дверь -- во плоти, так сказать. Я могу дотронуться до нее и руками.';
			end
		elseif w == sp_tele and sp_tele._state == nil then
			if not s._revealed then
				return 'Пока эта дверь -- лишь контур на стене, сдвинуть ее никак невозможно.';
			else
				if not s._opened then
					return 'Вот она, входная дверь -- во плоти, так сказать. Я могу дотронуться до нее и руками.';
				else
					return 'Дверь и так уже открыта!';
				end
			end
		end
	end,
}

--foyer

foyer = room {
	nam = 'Первый этаж. Прихожая',
	var { pic = 'gfx/foyer0.png' },
	dsc = [[
		В прихожей и в самом деле светло, можно даже сказать, уютно. Если, конечно, не обращать внимания на довольно странные вкусы прежнего владельца.
	]],
	obj = { 'carpet', 'armor', 'chain', 'blade', 'wardrobe', 'stone' },
	way = { vroom('В шкаф', 'alchemy'):disable() },
	entered = function ()
		set_music('mus/foyer.ogg');
		return 'Как только я перешагиваю через порог, дверь магическим -- каким же еще? -- образом исчезает... Что ж, пути назад нет. Только вперед!';
	end,
	exit = function ()
		sp_anim._state = nil;
		return true;
	end,
}

carpet = obj {
	nam = 'ковер',
	dsc = 'Пол устлан вызывающе красным {ковром} с золотым шитьем.',
	act = 'А я думал, мода украшать жилище поеденными молью кусками ткани прошла.',
	used = function (s,w)
		if w == sp_anim and sp_anim._state == nil then
			return 'Меня всегда интересовала возможность создания летающих ковров, но столь дырявый экспонат для экспериментов явно не подходит.';
		elseif w == sp_tele then
			return 'Сделав пасс руками, я приподнимаю ковер в надежде, что хозяин хранил под ним что-то ценное... Что ж, зато понятно, куда девался мусор при уборке.';
		end
	end,
}

armor = obj {
	_chained = true,
	nam = 'доспехи',
	dsc = 'В углу стоит полный комплект волшебных {лат}.',
	act = function (s)
		if seen (stone) then
			p 'Прекрасный образчик боевой брони военного мага Эпохи легенд. Сейчас таких уже не сыщешь.';
			if s._chained then
				if disabled(chain) then
					chain:enable();
				end				
				p 'Правда, их зачем-то приковали к стене цепью...';
			end
		else
			return 'Хорошие латы!.. Латы благодарно громыхают.';
		end
	end,
	used = function (s,w)
		if w == sp_anim then
			if sp_anim._state == nil then
				sp_anim._state = 'armor';
				sp_anim._active = 0;
				set_sound('snd/animate.ogg');				
			end
			return '\"Я ЕСТЬ ЛАТЫ!\"';
		elseif w == sp_tele then
			return 'Есть более продуктивные способы управлять такой грудой железа.';
		end
	end,
}

chain = obj {
	nam = 'цепь',
	dsc = function ()
		if armor._chained then
			p 'Они прикованы к стене массивной {цепью}!';
		else
			p 'Рядом на полу лежит перебитая {цепь},';
		end
	end,
	act = 'На такие цепи обычно сажают какую-нибудь фантастическую живность вроде мантикор.',
	used = function (s,w)
		if armor._chained then
			if w == sp_freeze then
				return 'Такому закаленному металлу не страшны перепады температуры.';
			elseif w == sp_anim and sp_anim._state == 'armor' then
				return 'Цепь закреплена между лопаток панциря, и латы не могут до нее дотянуться.';
			elseif w == sp_tele then
				return 'Взмахом руки я тяну цепь на себя, но она прочно вделана в стену.';
			elseif w == sp_zap then
				return 'Я посылаю разряд в цепь, но он заземляется.';
			end
		end
	end,
}:disable();

blade = obj {
	_damage = 0,
	nam = 'орудие',
	dsc = function (s)
		if armor._chained then
			if s._damage == 0 then
				p 'Немного выше, под потолком висит странного вида гигантское {лезвие}.';
			elseif s._damage == 1 then
				p 'Немного выше на хлипком креплении висит гигантское {лезвие}.';
			else
				p 'Немного выше, опасно накренившись, болтается гигантское {лезвие}!';
			end
		else
			p 'поверх которой лежит раздробившее ее {орудие}.';
		end
	end,
	act = function ()
		if armor._chained then
			p 'И кому только может прийти в голову вешать такое в своей прихожей?.. Да еще и на таком хлипком креплении.';
		else
			p 'А если бы оно упало кому-нибудь на голову?.. На лезвии нанесено клеймо кузницы \"DAMOCLES\".';
		end
	end,
	used = function (s,w)
		if armor._chained and not disabled(chain) then
			if w == sp_tele then
				if s._damage == 0 then
					return 'Я взмахиваю руками, но лезвие лишь слегка сдвигается в сторону. Еще все крепления на месте.';
				elseif s._damage == 1 then
					s._damage = 2;
					set_sound('snd/telek.ogg');
					return 'Взмахиваю посильнее, вторая веревка лопается, и лезвие начинает опасно раскачиваться... Я бы предпочел находиться подальше, когда оно упадет.';
				elseif s._damage == 2 then
					set_sound('snd/telek.ogg');
					armor._chained = false;
					if stone._frozen then
						here().pic = 'gfx/foyer3.png';
					else
						here().pic = 'gfx/foyer2.png';
					end
					return 'Еще один толчок, и последнее крепление не выдерживает. Лезвие с грохотом падает вниз, сокрушая первое, что попалось на пути: цепь, державшую латы... Теперь доспехи свободны!';
				end
			elseif w == sp_zap then
				if s._damage == 0 then
					s._damage = 1;
					set_sound('snd/zap.ogg');
					return 'Прицелившись, я направляю разряд на веревку, удерживающую лезвие. В цель! Веревка перебивается точно посередине.';
				elseif s._damage == 1 then
					s._damage = 2;
					set_sound('snd/zap.ogg');
					return 'Еще один разряд, и лопается вторая веревка. Лезвие начинает опасно раскачиваться... Я бы предпочел оказаться подальше, когда оно упадет.';
				elseif s._damage == 2 then
					return 'Я вижу, что последняя веревка вот-вот оборвется, но из-за того, что лезвие так сильно раскачивается, не могу прицелиться.';
				end
			end
		end
	end,
}

wardrobe = obj {
	_opened = false,
	nam = 'шкаф',
	dsc = function (s)
		if seen (stone) then
			p 'В дальнем конце прихожей стоит {шкаф},';
		else
			if not s._opened then
				p 'В дальнем конце прихожей стоит {шкаф}.';
			else
				p 'За распахнутой дверью шкафа простирается {пустота}.';
			end
		end
	end,
	act = function (s)
		if seen (stone) then
			return 'Говорят, платяные шкафы используют для перемещений в пространстве... Чтобы узнать наверняка, нужно убрать с дороги валун.';
		else
			if not s._opened then
				s._opened = true;
				set_sound('snd/success.ogg');
				return 'Я поворачиваю древние ручки, и одна из створок медленно и бесшумно отворяется.';
			else
				return 'Если долго смотреть в пустоту, пустота может всмотреться в тебя...';
			end	
		end
	end,
	used = function (s,w)
		if w == sp_light then
			if s._opened then
				ways()[1]:enable();
				set_sound('snd/light.ogg');
				return 'С магическим освещением становится видно, что в пустоте висят ступеньки, образующие винтовую лестницу.';
			end
		elseif w == sp_tele then
			if seen (stone) then
				return 'Валун плотно прижат к шкафу, так что двери вообще не могут пошевелиться.';
			else
				if not s._opened then
					return 'Теперь, когда на пути нет валуна, я могу подойти к шкафу сам.';
				else
					return 'Дверь и так уже открыта.';
				end
			end
		end
	end,
}

stone = obj {
	_frozen = false,
	nam = 'валун',
	dsc = function (s)
		if not s._frozen then
			p 'дорогу к которому преграждает огромный {валун}.';
		else
			p 'перед которым возвышается обледенелый {валун}.';
		end
	end,
	act = function (s)
		if not s._frozen then
			return 'Нет, самому такой мне нипочем не сдвинуть.';
		else
			return 'Я пытаюсь ухватиться за камень, но у меня соскальзывают руки... Впрочем, кого я обманываю: мне все равно его не своротить.';
		end
	end,
	used = function (s,w)
		if w == sp_freeze then
			if not s._frozen then
				s._frozen = true;
				set_sound('snd/freeze.ogg');
				if armor._chained then
					here().pic = 'gfx/foyer1.png';
				else
					here().pic = 'gfx/foyer3.png';
				end
				return 'Я выдыхаю клуб ледяного воздуха, и валун медленно, но верно покрывается ледяной коркой.';
			else
				return 'Камень и так уже заледенел.';
			end
		elseif w == sp_anim and sp_anim._state == 'armor' then
			if not armor._chained then
				if not s._frozen then
					return 'Ожившие доспехи приближаются к валуну... Удар долго еще звоном отдается в ушах, но камень будто бы не повредился.';
				else
					remove(s);
					sp_anim._state = nil;
					set_sound('snd/animate.ogg');
					here().pic = 'gfx/foyer4.png';
					return 'Ожившие доспехи боевой походкой приближаются к валуну... Удар, еще удар! Промерзший насквозь камень рассыпается в пыль.';
				end
			end
		elseif w == sp_light then
			if not s._frozen then
				return 'Камень явно не отсюда и, кажется, много повидал на своем веку. Удается разобрать только первую строчку на древнем наречии: \"SI AD SINISTRAM IERIS...\"';
			else
				return 'Свет приятно переливается по ледяной корке, но того, что под ней, разобрать не получается.';
			end
		elseif w == sp_tele then
			return 'Поднатужившись, я пытаюсь сдвинуть валун хотя бы на пядь, но он будто врос в пол.';
		elseif w == sp_zap then
			if not s._frozen then
				return 'Собрав силу в кулак, я посылаю разряд в камень, но тому все нипочем.';
			else
				return 'Собрав силу в кулак, я посылаю разряд в обледеневший камень, и от него отлетает крошечный кусочек. Начало положено, но продолжать в таком темпе значит потратить минимум месяц.';
			end
		end
	end,
}

--alchemy

alchemy = room {
	_mist = false,
	_riddle = 0,
	nam = 'Второй этаж. Лаборатория',
	var { pic = 'gfx/alchemy0.png' },
	dsc = [[
		Сразу видно, что лабораторией долго и активно пользовались -- с переменным результатом. Стоит повнимательнее смотреть под ноги, чтобы не наступить на "последствия" какого-нибудь неудавшегося опыта.
	]],
	obj = { 'bench', 'cabinet', 'sheets', 'recipe', 'oven', 'heater', 'window', 'flasks', 'vent' },
	way = { vroom('К шкафчику', 'bottles'):disable(), vroom('К горелке', 'laboratory'):disable(), vroom('В вентиляцию', 'library_dark'):disable() },
	life = function ()
		add_sound('snd/mist.ogg');
	end,
	entered = function (s)
		if not visited(s) then
			set_music('mus/alchemy.ogg');
			s._riddle = rnd(4);
			return 'Потайная лестница приводит меня на второй этаж. Люк тут же захлопывается, и заново поддеть его не выходит.';
		elseif s._mist then
			ways()[1]:disable();
			ways()[2]:disable();
			return 'Все вокруг приобретает зеленоватый оттенок, а я чувствую невообразимую легкость. Меня будто поднимает вверх.';
		end
	end,
	exit = function (s)
		sp_anim._state = nil;
		sp_tele._state = nil;
		lifeoff(s);
		return true;
	end,
}

bench = obj {
	nam = 'верстак',
	dsc = 'Центральное место в помещении занимает {рабочий стол},',
	act = function ()
		if alchemy._mist then
			return 'Руки и все мое тело обратились в туман. Я не могу ничего коснуться.';
		else
			return 'Верстак весь уставлен алхимическим оборудованием: тут и реторты, и перегонные кубы, и прочая, и прочая... Все очень старое и навряд ли пригодно для работы.';
		end
	end,
	used = function (s,w)
		if w == sp_anim and sp_anim._state == 'oven' then
			return '\"Вот помню, лет двадцать назад тут был такой пожар... Или десять?\"';
		end
	end,
}

cabinet = obj {
	_opened = false,
	nam = 'шкафчик',
	dsc = 'над которым висит добротно сколоченный {шкафчик}.',
	act = function (s)
		if alchemy._mist then
			return 'Руки и все мое тело обратились в туман. Я не могу ничего коснуться.';
		else
			if not s._opened then
				s._opened = true;
				ways()[1]:enable();
			end
			return 'На шкафчик нанесены особые символы, обозначающие, что внутри хранятся алхимические реагенты.';
		end
	end,
	used = function (s,w)
		if w == sp_anim and sp_anim._state == 'oven' then
			return '\"При перегонке Магнус добавил эссенцию жизни, и теперь бутылки разговаривают без всяких заклинаний.\"';
		end
	end,
}

sheets = obj {
	_hint = false,
	nam = 'формулы',
	dsc = 'Вся стена утыкана гвоздями, к которым прикреплены {обрывки пергамента}.',
	act = function (s)
		if alchemy._mist then
			return 'Руки и все мое тело обратились в туман. Я не могу ничего коснуться.';
		else
			if disabled(recipe) then
				if s._hint then
					recipe:enable();
					return 'Порывшись в куче записей, так и не нахожу того, о чем говорила печь... Однако мне на глаза попадается удивительно неисписанный листок...';
				else
					return 'Перелистываю пергаменты... Куча перечеркнутых формул да примитивные зарисовки. Наверняка тут что-то есть, но без подсказки не отыскать.';
				end
			else
				return 'На прочих пергаментах нет ничего интересного -- только различные удавшиеся и неудавшиеся формулы да примитивные зарисовки.';
			end
		end
	end,
	used = function (s,w)
		if w == sp_anim and sp_anim._state == 'oven' then
			if not s._hint then
				s._hint = true;
				return '\"Где-то среди этих записей есть рецепт, над которым Магнус трудился очень долго. Что-то страшно секретное: кажется, обращение в пар.\"';
			else
				if disabled(recipe) then
					return '\"Ну как, нашел рецепт обращения в пар?\"';
				else
					return '\"Большая часть этих записей -- неудачные любовные стихи некоей Лауре.\"';
				end
			end
		elseif w == sp_light then
			return 'На листках волшебными чернилами записаны обрывки каких-то строк. Видимо, в молодости наставник увлекался стихоплетством!.. Не очень удачно, следует признать.';
		elseif w == sp_zap then
			return 'Пусть останутся для истории.';
		end
	end,
}

recipe = obj {
	_lookat = false,
	nam = 'рецепт',
	dsc = 'Один из пергаментов подозрительно {пуст}!',
	text = {
		[1] = '^\"Каплю гнева, каплю грусти,^Безразличия глоток,^И земля тебя отпустит -– ^Улетишь под потолок!\"',
		[2] = '^\"Эгоизм смешай с весельем,^Ярость бросить не забудь!^Невесомым станет тело,^Дымом тронешься ты в путь!\"',
		[3] = '^\"Здравый смысл разведи^Ты ворчаньем и хандрой:^Дымкой лёгкой улетишь,^Словно крылья за спиной!\"',
		[4] = '^\"К легкому веселью^Добавить здравый смысл,^Заносчивости каплю -- ^И превратишься в дым!\"',
	},
	act = function ()
		if alchemy._mist then
			return 'Руки и все мое тело обратились в туман. Я не могу ничего коснуться.';
		else
			return 'Присмотревшись поближе, я замечаю следы магических чернил. Возможно, что-то тут все-таки написано...';
		end
	end,
	used = function (s,w)
		if w == sp_anim and sp_anim._state == 'oven' then
			if not s._lookat then	
				return '\"Ага, вот я и говорю: что-то страшно секретное!\"';
			else
				return '\"А ведь умно, да? Никто из волшебников и не догадается, что это формула!\"';
			end
		elseif w == sp_light then
			if not s._lookat then
				s._lookat = true;
			end
			set_sound('snd/light.ogg');
			return 'В волшебном свете на листке проступают строки:'..s.text[alchemy._riddle];
		end
	end,
}:disable();

oven = obj {
	nam = 'печь',
	dsc = 'У стены стоит массивная чугунная алхимическая {печь},',
	act = function ()
		if alchemy._mist then
			return 'Руки и все мое тело обратились в туман. Я не могу ничего коснуться.';
		else
			return 'Меня никак не отпускает ощущение, что внешний вид печи очень напоминает человеческое лицо...';
		end
	end,
	used = function (s,w)
		if w == sp_freeze then
			if sp_anim._state == 'oven' then
				return '\"Прикрой окно, что-то дует.\"';
			else
				return 'Печь и так давно остыла.';
			end
		elseif w == sp_anim then
			if sp_anim._state == nil then
				sp_anim._state = 'oven';
				sp_anim._active = 0;
				set_sound('snd/animate.ogg');				
				return '-- Кто посмел потревожить мой сон?^-- Ух ты, говорящая печь! Чего только не увидишь в этой башне.';
			else
				return '\"Ну да, я печь. Говорящая. Научное оборудование, так что по статусу положено.\"';
			end
		elseif w == sp_tele then
			if sp_tele._state == nil then
				if sp_anim._state == 'oven' then
					return '\"У нас кто-то затеял перестановку?\"';
				else
					return 'Боюсь, для меня это пока тяжеловато.';
				end
			else
				if sp_anim._state == 'oven' then
					return '\"Можешь пользоваться. Вроде бы нормальная бутылка.\"';
				else
					return 'В печи ставят котлы. Колбы не выдерживают высокой температуры.';
				end
			end
		elseif w == sp_zap then
			if sp_anim._state == 'oven' then
				return '\"Бр-р! Бодрит.\"';
			else
				return 'До наступления зимы еще далеко. Разжигать печь незачем.';
			end
		end
	end,
}

heater = obj {
	_examined = false,
	nam = 'горелка',
	dsc = 'над которой установлена {горелка} для приготовления зелий.',
	act = function (s)
		if alchemy._mist then
			return 'Руки и все мое тело обратились в туман. Я не могу ничего коснуться.';
		else
			p 'Полностью функциональная горелка, к которой подходят трубки смесителя.';
			if not s._examined then
				ways()[2]:enable();
			end
			if not disabled(flask) then
				p 'На ней стоит колба, готовая к приготовлению зелий.';
			elseif not disabled(mixture) then
				p 'На ней стоит недоготовленная еще смесь.';
			elseif not disabled(potion) then
				p 'На ней меня дожидается готовое зелье.';
			elseif not disabled(fail) then
				p 'На ней меня дожидается какая-то непонятная смесь.';
			end
		end
	end,
	used = function (s,w)
		if w == sp_anim and sp_anim._state == 'oven' then
			return '\"Да, в былые времена позажигали мы тут с Магнусом.\"';
		elseif w == sp_tele and sp_tele._state == 'flask' then
			sp_tele._state = nil;
			flask:enable();
			set_sound('snd/telek.ogg');
			return 'Я аккуратно помещаю колбу на горелку.';
		elseif w == sp_zap then
			return 'Зажигать горелку надо аккуратно и с близкого расстояния.';
		end
	end,
}

window = obj {
	nam = 'окно',
	dsc = '{Окно} в восточной стене распахнуто настежь.',
	act = function ()
		if alchemy._mist then
			return 'За окном дует ветерок. Не буду подлетать ближе -- как бы меня не унесло...';
		else
			return 'Я выглядываю в окно, а из кустов на меня немигающе смотрят три глаза: два синих, и один зеленый... Судоржно сглотнув, я отхожу подальше.';
		end
	end,
	used = function (s,w)
		if w == sp_anim and sp_anim._state == 'oven' then
			return '\"Я бы на твоем месте держался подальше. Маркус уже подрос, а его давно не кормили.\"';
		end
	end,
}

flasks = obj {
	nam = 'склянки',
	dsc = 'В углу стоит сундук, доверху наполненный разного рода {склянками},',
	act = function ()
		if alchemy._mist then
			return 'Руки и все мое тело обратились в туман. Я не могу ничего коснуться.';
		else
			return 'По инструкции брать колбы можно только в специальных перчатках, чтобы не занести непредвиденные элементы в зелье.';
		end
	end,
	used = function (s,w)
		if w == sp_anim then
			if sp_anim._state == nil then
				if visited(bottles) then
					return 'Моих скромных способностей явно недостаточно, чтобы заставить их говорить.';
				else
					return 'Зачем их оживлять? Они мне что-то полезное смогут рассказать?';
				end
			else
				return '\"Осторожнее с ними. Твой предшественник мало уделял внимания их обработке.\"';
			end
		elseif w == sp_tele then
			if sp_tele._state == nil then
				if not disabled(flask) or not disabled(mixture) or not disabled(potion) or not disabled(fail) or seen(black) then
					return 'На горелке уже стоит колба. Новая мне пока что не нужна.';
				else
					sp_tele._state = 'flask';
					set_sound('snd/telek.ogg');
					return 'Я бережно поднимаю из сундука верхнюю пустую колбу.';
				end
			else
				sp_tele._state = nil;
				set_sound('snd/telek.ogg');
				return 'Я аккуратно возвращаю колбу обратно в сундук.';
			end
		end
	end,
}

vent = obj {
	_reached = false,
	nam = 'вентиляция',
	dsc = 'а под самым потолком расположена {вентиляционная решетка}.',
	act = function (s)
		if alchemy._mist then
			if not s._reached then
				s._reached = true;
				set_sound('snd/success.ogg');
				ways()[3]:enable();
			end
				return 'Хм, труба ведет вверх, следовательно, по ней можно попасть на верхние этажи...';
		else
			return 'В таких помещениях без вытяжки никуда.';
		end
	end,
	used = function (s,w)
		if w == sp_anim and sp_anim._state == 'oven' then
			return '\"Насколько мне известно, это единственный путь наверх.\"';
		end
	end,
}

laboratory = room {
	nam = 'Приготовление зелий',
	pic = 'gfx/laboratory.png',
	dsc = [[
		Полностью оборудованное рабочее место для приготовления зелий. Единственное место в помещении, о котором заботились.
	]],
	obj = { 'pipes', 'r_valve', 'o_valve', 'y_valve', 'g_valve', 'b_valve', 'i_valve', 'v_valve', 'pad', 'flask', 'mixture', 'potion', 'fail', 'black' },
	way = { vroom('Отойти', 'alchemy') },
}

pipes = obj {
	nam = 'трубки',
	dsc = 'Из стены идет сеть трубок с разноцветными {клапанами}, которые соединяются в смеситель.',
	act = function (s)
		if recipe._lookat then
			s:disable();
			r_valve:enable();
			o_valve:enable();
			y_valve:enable();
			g_valve:enable();
			b_valve:enable();
			i_valve:enable();
			v_valve:enable();
			return 'Все клапаны в рабочем состоянии и расположены как цвета радуги.';
		else
			return 'Не вижу смысла что-то бездумно смешивать...';
		end
	end,
}

r_valve = obj {
	nam = 'красный',
	dsc = 'Из стены идет сеть разноцветных трубок: {красная},',
	act = function ()
		return mix(1);
	end,
}:disable();

o_valve = obj {
	nam = 'оранжевый',
	dsc = '{оранжевая},',
	act = function ()
		return mix(2);
	end,
}:disable();

y_valve = obj {
	nam = 'желтый',
	dsc = '{желтая},',
	act = function ()
		return mix(3);
	end,
}:disable();

g_valve = obj {
	nam = 'зеленый',
	dsc = '{зеленая},',
	act = function ()
		return mix(4);
	end,
}:disable();

b_valve = obj {
	nam = 'голубой',
	dsc = '{голубая},',
	act = function ()
		return mix(5);
	end,
}:disable();

i_valve = obj {
	nam = 'синий',
	dsc = '{синяя}',
	act = function ()
		return mix(6);
	end,
}:disable();

v_valve = obj {
	nam = 'фиолетовый',
	dsc = 'и {фиолетовая}. Все они соединяются в смеситель.',
	act = function ()
		return mix(7);
	end,
}:disable();

pad = obj {
	nam = 'горелка',
	dsc = 'Под краником установлена баня с {конфоркой}.',
	act = 'Сюда устанавливается алхимическая колба для смешивания зелья, а в конце подогревается, чтобы ускорить реакцию.',
	used = function (s,w)
		if w == sp_tele then
			if seen (flask) or seen (mixture) or seen (potion) or seen (fail) or seen (black) then
				return 'Не надо убирать колбу отсюда.';
			end
		elseif w == sp_zap then
			if mixture._flavor == 0 then
				return 'Пока зелье не готово, не надо его подогревать.';
			else
				if mixture._success then
					potion:enable();
				else
					if not disabled(black) then
						fail:enable();
					else
						black:enable();
					end
				end
				mixture._base = 0;
				mixture._essence = 0;
				mixture._flavor = 0;
				mixture:disable();
				lifeoff('mixture');
				set_sound('snd/zap.ogg');
				return 'Алаказам!.. Несколько секунд, и у меня получается...';
			end
		end
	end,
}

flask = obj {
	nam = 'склянка',
	dsc = 'В бане стоит пустая {колба}.',
	act = 'Склянка пустая, но все равно лучше ее не трогать, дабы не занести что-нибудь постороннее.',
	used = function (s,w)
		if w == sp_tele then
			return 'Не надо убирать колбу отсюда.';
		elseif w == sp_zap then
			return 'Аккуратнее, расколется!';
		end
	end,
}:disable();

mixture = obj {
	_base = 0,
	_essence = 0,
	_flavor = 0,
	_success = false,
	color = {
		[0] = '--отсутствует--',
		[1] = '--красный--',
		[2] = '--оранжевый--',
		[3] = '--желтый--',
		[4] = '--зеленый--',
		[5] = '--голубой--',
		[6] = '--синий--',
		[7] = '--фиолетовый--',
	},
	nam = 'смесь',
	dsc = 'В бане стоит {колба} с неактивной смесью.',
	act = 'Пока зелье не готово, его лучше не трогать. А то легко занести что-нибудь постороннее.',
	life = function (s)
		if me().where == 'laboratory' then
			p ('Текущий состав зелья:');
			p ('^ОСНОВА: '..s.color[s._base]);
			p ('^ЭССЕНЦИЯ: '..s.color[s._essence]);
			p ('^АРОМАТ: '..s.color[s._flavor]);
		end
	end,
	used = function (s,w)
		if w == sp_freeze then
			return 'Мне не нужна консервированная основа.';
		elseif w == sp_tele then
			return 'Не надо убирать колбу отсюда.';
		elseif w == sp_zap then
			if mixture._flavor == 0 then
				return 'Аккуратнее, расколется!.';
			else
				return 'Если воздействовать на смесь напрямую, то можно убить элементы!';
			end
		end
	end,
}:disable();

potion = obj {
	nam = 'зелье',
	dsc = 'В бане стоит {колба}, а внутри нее будто клубится зеленоватая дымка!',
	act = function (s)
		set_sound('snd/mist.ogg');
		alchemy._mist = true;
		alchemy.hideinv = true;
		alchemy.pic = 'gfx/alchemy1.png';
		lifeon('alchemy');
		s:disable();
		walk('alchemy');
		return true;
	end,
}:disable();

fail = obj {
	nam = 'неудача',
	dsc = 'В бане стоит {колба} со смесью какого-то непонятного оттенка.',
	act = function (s)
		set_sound('snd/glass.ogg');
		s:disable();
		return 'Где-то я дал промашку. Вздохнув, я выкидываю неудачную смесь в окно -- чем я хуже бывшего хозяина?.. За окном раздается довольное чавканье.';
	end,
}:disable();

black = obj {
	nam = 'черная бутылка',
	dsc = 'В бане стоит черная, будто обуглившаяся {колба}...',
	act = function (s)
		set_sound('snd/laugh.ogg');
		remove(s);
		return 'На поверхности бутылки загораются красные глаза и дикая ухмылка, и она с безумным смехом исчезает!.. Кажется, я где-то перестарался.';
	end,
	used = function (s,w)
		if w.isspell then
			set_sound('snd/laugh.ogg');
			remove(s);
			return 'На поверхности бутылки загораются красные глаза и дикая ухмылка, и она с безумным смехом исчезает!.. Кажется, я где-то перестарался.';
		end
	end,
}:disable();

bottles = room {
	hideinv = true,
	nam = 'Коллекция реагентов',
	pic = 'gfx/bottles.png',
	dsc = [[
		Удивительно, но в шкафчике остались все основные алхимические реагенты, аккуратно расставленные по полочкам.
	]],
	react = {
		[1] = '^\"А ну быстро закрыл дверь с той стороны!\"',
		[2] = '^\"Дабы не портить отношения, скажу привет.\"',
		[3] = '^\"Ох, снова эти поклонники!\"',
		[4] = '^\"О, новое лицо! Как дела?\"',
		[5] = '^\"Ну все, сейчас начнется...\"',
		[6] = '^\"Так-так, и кто это у нас тут нарисовался?\"',
		[7] = '^\"Кажется, ветер.\"',
	},
	bye = {
		[1] = '^\"А тут что, кто-то был?\"',
		[2] = '^\"Ни тебе здравствуйте, ни тебе до свидания...\"',
		[3] = '^\"Тебе-то хорошо, ты можешь уйти...\"',
		[4] = '^\"Приятно было поболтать! Заходи еще!\"',
		[5] = '^\"Как, ты оставишь меня здесь?! Нахал!\"',
		[6] = '^\"Думаю, ты получил то, что хотел.\"',
		[7] = '^\"Верно-верно, скатертью дорожка!\"',
	},	
	obj = { 'yellow', 'red', 'green', 'indigo', 'orange', 'violet', 'blue' },
	way = { vroom('Закрыть', 'alchemy') },
	entered = function (s)
		local i1 = rnd(7);
		local i2 = rnd(7);
		while (i2 == i1) do
			i2 = rnd(7);
		end
		local i3 = rnd(7);
		while (i3 == i1) or (i3 == i2) do
			i3 = rnd(7);
		end
		return 'Я открываю дверцу шкафчика, и меня приветствует нестройный хор голосов: '..s.react[i1]..s.react[i2]..s.react[i3];
	end,
	left = function (s)
		local i1 = rnd(7);
		local i2 = rnd(7);
		while (i2 == i1) do
			i2 = rnd(7);
		end
		local i3 = rnd(7);
		while (i3 == i1) or (i3 == i2) do
			i3 = rnd(7);
		end
		return 'Я закрываю шкафчик, а вслед мне еще слышится: '..s.bye[i1]..s.bye[i2]..s.bye[i3];
	end,
}

yellow = obj {
	nam = 'желтый',
	dsc = 'На самом видном месте, прямо в лунном свете красуется {желтая бутылка}.',
	talk = {
		[1] = '\"Бесспорно, я здесь самое лучшее зелье!\"',
		[2] = '\"Все кругом - просто склянки с разноцветной жидкостью. Ты, кстати, не исключение.\"',
		[3] = '\"У меня концентрация 76,6%! А чего добился ты?\"',
		[4] = '\"Между прочим, я заняла первое место по желтизне!\"',
	},
	act = function (s)
		local t = rnd(4);
		return s.talk[t];
	end,
}

red = obj {
	nam = 'красный',
	dsc = 'Рядом, подавляя соседку своим размером стоит сосуд с {красной жидкостью}.',
	talk = {
		[1] = '\"Сейчас я грохнусь тебе на голову - посмотрим, кто кого!\"',
		[2] = '\"Всех вас таких умных ненавижу!\"',
		[3] = '\"Будь у меня руки, я бы задала тебе трепку!\"',
		[4] = '\"Смотрю на тебя и прямо закипаю!\"',
	},
	act = function (s)
		local t = rnd(4);
		return s.talk[t];
	end,
}

green = obj {
	nam = 'зеленый',
	dsc = 'На {зеленой баночке} кто-то нарисовал смешную рожицу.',
	talk = {
		[1] = '\"Жду-не дождусь, когда меня применят для чего-нибудь полезного!\"',
		[2] = '\"А как тебя зовут? Давай дружить!\"',
		[3] = '\"Такой рецепт слыхала -- обхохочешься!\"',
		[4] = '\"Не правда ли сегодня чудесный день?\"',
	},
	act = function (s)
		local t = rnd(4);
		return s.talk[t];
	end,
}

indigo = obj {
	nam = 'синий',
	dsc = 'Бутыль с {синей жидкостью} помутнела и покрыта паутиной.',
	talk = {
		[1] = '\"Эх, не тот волшебник нынче пошел. Не тот.\"',
		[2] = '\"Тебя, милок, на свете не было, когда меня смешивали!\"',
		[3] = '\"Эх, помню, в прошлой эпохе...\"',
		[4] = '\"Ох, что-то опять осадок начал выпадать...\"',
	},
	act = function (s)
		local t = rnd(4);
		return s.talk[t];
	end,
}

orange = obj {
	nam = 'оранжевый',
	dsc = '{Оранжевая бутылка} стоит на специальной подставке.',
	talk = {
		[1] = '\"Хорошо, что я стою на нижней полке. Шанс разбиться меньше всего.\"',
		[2] = '\"Технически я всего лишь бутылка с цветной жидкостью.\"',
		[3] = '\"Температура в помещении на четыре градуса ниже оптимальной для хранения зелий.\"',
		[4] = '\"Главное -- не делать резких движений.\"',
	},
	act = function (s)
		local t = rnd(4);
		return s.talk[t];
	end,
}

violet = obj {
	nam = 'фиолетовый',
	dsc = 'Склянка с {фиолетовой жидкостью} не похожа на другие.',
	talk = {
		[1] = '\"О, а я тебя и не заметила...\"',
		[2] = '\"Ты все еще здесь?\"',
		[3] = '\"Прости, как там тебя?.. Впрочем, мне-то какая разница.\"',
		[4] = '\"Мне кто-то свет загораживает...\"',
	},
	act = function (s)
		local t = rnd(4);
		return s.talk[t];
	end,
}

blue = obj {
	nam = 'голубой',
	dsc = 'Где-то в самом дальнем углу я замечаю {голубую бутылку}.',
	talk = {
		[1] = '\"Думаешь, легко быть зельем?\"',
		[2] = '\"Так и вижу, что ты хочешь использовать меня в своих гнусных целях.\"',
		[3] = '\"За что мне все это?!\"',
		[4] = '\"Еще немного, и я совсем выветрюсь...\"',
	},
	act = function (s)
		local t = rnd(4);
		return s.talk[t];
	end,
}

--library

library_dark = room {
	hideinv = false,
	nam = 'Третий этаж. Библиотека',
	var { pic = 'gfx/dark0.png' },
	dsc = [[
		Судя по трудноразличимым громадам, окружающим меня, я нахожусь в помещении наподобие библиотеки. Без света здесь и убиться недолго.
	]],
	obj = { 'column', 'torch', 'bookcase', 'puddle', 'shelves', 'ropes', 'switch' },
	entered = function ()
		if not visited(s) then
			set_music('mus/library.ogg');
			return 'Откашливаясь и отплевываясь от пыли, я материализуюсь из вентиляционной решетки. Темнота вокруг -- хоть глаз коли, и ни единого окна...';
		end
	end,
}

column = obj {
	_lit = false,
	nam = 'колонна',
	dsc = function (s)
		if s._lit then
			return 'Рядом со мной высится {колонна},';
		else
			return 'В темноте я различаю силуэт {чего-то} очень высокого.';
		end
	end,
	act = 'На ощупь нечто холодное и каменное.',
	used = function (s,w)
		if w == sp_light then
			if not s._lit then
				if bookcase._lit then
					s._lit = true;
					bookcase._lit = false;
					torch:enable();
					puddle:disable();
					shelves:disable();
					set_sound('snd/light.ogg');
					here().pic = 'gfx/dark1.png';
					return 'Держа шар света перед собой, я возвращаюсь к колонне.';				
				else
					s._lit = true;
					torch:enable();
					bookcase:enable();
					set_sound('snd/light.ogg');
					here().pic = 'gfx/dark1.png';
					return 'Немного света не помешает...';
				end
			end
		end
	end,
}

torch = obj {
	_powered = false,
	nam = 'фонарь',
	dsc = 'на самом верху которой установлен {прожектор}.',
	act = 'По агрессивным пропорциям угадывается, что производитель этого агрегата -- компания \"ФРОБОЗЗ\".',
	used = function (s,w)
		if w == sp_light then
			return 'Такие фонари работают от искусственной искры, а не от магической. Якобы так безопаснее.';
		elseif w == sp_tele then
			return 'Незачем мне его с собой повсюду таскать. К тому же он соединен с проводом.';
		elseif w == sp_zap then
			if s._powered then
				set_sound('snd/zap.ogg');
				walk('library');
				return 'От посланной мной искры начинает работать встроенный мотор, и лампа прожектора медленно загорается...';
			else
				return 'Я посылаю в прожектор искру, но ничего не происходит. Видимо, отключено основное питание -- еще одна из мер предосторожности.';
			end
		end
	end,
}:disable();

bookcase = obj {
	_lit = false,
	nam = 'шкаф',
	dsc = function (s)
		if s._lit then
			return 'Я стою около очень высокого {книжного шкафа}.';
		else
			return 'Чуть поодаль высится еще одна {громадина}.';
		end
	end,
	act = function (s)
		if s._lit then
			return 'Наверное, здесь стоят интересные книги, но в таком неверном освещении читать их неудобно.';
		else
			return 'Тоже что-то высокое, но деревянное.';
		end
	end,
	used = function (s,w)
		if w == sp_light then
			if not s._lit then
				if column._lit then
					s._lit = true;
					column._lit = false;
					torch:disable();
					puddle:enable();
					shelves:enable();
					set_sound('snd/light.ogg');
					if puddle._frozen then
						here().pic = 'gfx/dark3.png';
					else
						here().pic = 'gfx/dark2.png';
					end
					return 'Я перевожу шар света в сторону и, осторожно ступая, перехожу в середину помещения.';				
				elseif shelves._lit then
					s._lit = true;
					shelves._lit = false;
					ropes:disable();
					switch:disable();
					column:enable();
					puddle:enable();
					set_sound('snd/light.ogg');
					here().pic = 'gfx/dark3.png';
					return 'Я отвожу свет в сторону и, внимательно смотря под ноги, возвращаюсь в середину помещения.';				
				end
			else
				return 'Наверное, здесь стоят интересные книги, но в таком неверном освещении их читать неудобно.';
			end
		end
	end,
}:disable();

puddle = obj {
	_frozen = false,
	nam = 'лужа',
	dsc = function (s)
		if s._frozen then
			return 'Под шкафом блестит ледяная {поверхность}.';
		else
			return 'На полу под шкафом разлита некая непонятная {лужа}.';
		end
	end,
	act = function (s)
		if s._frozen then
			return 'Скользко!';
		else
			return 'Хм-м... Какой-то подозрительно резкий у нее запах.';
		end
	end,
	used = function (s,w)
		if w == sp_freeze then
			if not s._frozen then
				s._frozen = true;
				set_sound('snd/freeze.ogg');
				here().pic = 'gfx/dark3.png';
				return 'Вдох-выдох, и поверхность лужи затягивается ледяной коркой, которая с каждой секундой становится все плотнее.';
			else
				return 'Я пробую лед ногой... Нет, еще сильнее замораживать не нужно.';
			end
		elseif w == sp_anim then
			if not s._frozen then
				return '\"БУЛЬ. Буль.\"';
			else
				return '...Тишина.';
			end
		elseif w == sp_zap then
			if not s._frozen then
				return 'И хотя на лекциях по технике безопасности с химическими веществами я спал, но правило номер один усвоил: не надо рядом с ними играться с искрой.';
			end
		end
	end,
}:disable();

shelves = obj {
	_lit = false,
	nam = 'полки',
	dsc = function (s)
		if s._lit then
			return 'Я стою в углу комнаты, рядом с плохо сохранившимся {стеллажом} для книг.';
		else
			return 'Чуть поодаль чернота сгущается бесформенной {массой}.';
		end
	end,
	act = function (s)
		if s._lit then
			return 'Здесь книг практически нет, а какие есть, до тех не дотянуться.';
		else
			return 'Нечто огромное и бесформенное, похожее на спящего горного тролля.';
		end
	end,
	used = function (s,w)
		if w == sp_light then
			if not s._lit then
				if puddle._frozen then
					s._lit = true;
					bookcase._lit = false;
					column:disable();
					puddle:disable();
					ropes:enable();
					set_sound('snd/light.ogg');
					here().pic = 'gfx/dark4.png';
					return 'Аккуратно, чтобы не поскользнуться, я двигаюсь дальше.';
				else
					return 'Там, думается, тоже полки с книгами, но наступать в эту булькающую черную жижу я не собираюсь!';
				end
			end
		end
	end,
}:disable();

ropes = obj {
	nam = 'веревки',
	dsc = 'Надо мной болтаются {веревки} непонятного назначения. Их концы уходят в темноту.',
	act = 'Я подергал за веревки. Ничего не произошло.',
	used = function (s,w)
		if w == sp_anim then
			return 'Веревки хищно тянутся в мою сторону. Я немедленно отменяю заклинание!';
		elseif w == sp_light then
			if disabled(switch) then
				switch:enable();
				set_sound('snd/light.ogg');
				return 'Подняв шар света повыше, в темноту между веревками, я замечаю рычаг выключателя!';
			end
		elseif w == sp_tele then
			return 'Я, конечно, могу заставить их сплестись в узел, но зачем это мне?';
		end
	end,
}:disable();

switch = obj {
	nam = 'выключатель',
	dsc = 'Где-то среди них затерялся {выключатель} питания электрического прожектора.',
	act = 'Так его не достать, а по канатам лазить я не мастак.',
	used = function (s,w)
		if w == sp_tele then
			if not torch._powered then
				torch._powered = true;
				set_sound('snd/telek.ogg');
				return 'Жестом я переключаю рычаг, и откуда-то начинает доноситься тихое гудение. Будем надеяться, этого хватит, чтобы запитать прожектор.';
			else
				return 'Если питание отключить, прожектор не заработает.';
			end
		end
	end,
}:disable();

library = room {
	nam = 'Третий этаж. Библиотека',
	var { pic = 'gfx/library0.png' },
	dsc = [[
		Электрический фонарь с тихим гудением освещает библиотеку. Полок много, но большинство из них пусты, что, впрочем, неудивительно.
	]],
	obj = { 'books', 'catalogue', 'reading', 'shelf', 'rope', 'chest', 'mirror', 'portal' },
	way = { vroom ('Читать книгу', 'runes'):disable(), vroom('В портал', 'attic'):disable() },
}

books = obj {
	nam = 'книжный шкаф',
	dsc = 'Центральное место в библиотеке занимает громадный {книжный шкаф}, в котором еще остались книги.',
	collection = {
		[1] = 'несколько томов из популярной детской серии: \"Молот ведьм\", \"Зубило чародеев\" и \"Долото друидов\".',
		[2] = 'пособие по уходу за орангутанами. Крайне странное чтиво.',
		[3] = 'запрятанный между книгами номер периодического издания \"W.I.T.C.H.\"',
		[4] = 'стопку тетрадей с конспектами лекций по древним языкам.',
	},
	act = function (s)
		if disabled(catalogue) then
			catalogue:enable();
			return 'На нижней полке стоит ящичек с алфавитными карточками!';
		else
			local c = rnd(4);
			p ('На полках я вижу '..s.collection[c]);
		end
	end,
}

catalogue = obj {
	_examined = false,
	nam = 'каталог',
	dsc = 'На нижней полке стоит {ящичек} с алфавитными карточками.',
	act = function (s)
		if not chest._tried then
			return 'В ящичке просто небольшая стопка карточек, по-видимому, к книгам, которые здесь еще остались.';
		else
			if not s._examined then
				s._examined = true;
				return 'Так, что-нибудь по рунам... Обереги. Проклятия. Символы...^А, вот она -- Энциклопедия рун! Стеллаж с литерой \"С\".';
			else
				return 'Я уже нашел книгу, которая меня интересует.';
			end
		end
	end,
}:disable();

reading = obj {
	_placed = false,
	nam = 'стол для чтения',
	dsc = function (s)
		if s._placed then
			return 'На стоящем рядом столе для чтения лежит раскрытая {книга}.';
		else
			return 'Рядом со шкафом стоит {стол для чтения}.';
		end
	end,
	act = function (s)
		if s._placed then
			return 'Книга озаглавлена: \"ЭНЦИКЛОПЕДИЯ РУН\".';
		else
			return 'Высокий, слегка наклоненный столик, предназначенный для изучения магических трудов.';
		end
	end,
	used = function (s,w)
		if w == sp_tele and sp_tele._state == 'book' then
			s._placed = true;
			sp_tele._state = nil;
			ways()[1]:enable();
			set_sound('snd/telek.ogg');
			here().pic = 'gfx/library1.png';
			return 'Я бережно опускаю книгу на стол для чтения и, сдув пыль, открываю ее.';
		end
	end,
}

shelf = obj {
	_pulled = false,
	_inplace = true,
	nam = 'стеллаж',
	dsc = function (s)
		if not reading._placed then
			if not s._pulled then
				return 'Поодаль высится ужасно старый {стеллаж}; половина полок у него сломаны.';
			else
				if s._inplace then
					return 'Поодаль высится ужасно старый стеллаж. На верхней полке стоит {книга}.';
				else
					return 'Поодаль высится ужасно старый {стеллаж}; половина полок у него сломаны.';
				end
			end
		else
			return 'Поодаль высится ужасно старый {стеллаж}; половина полок у него сломаны.';
		end
	end,
	act = function (s)
		if not reading._placed then
			if not s._pulled then
				if not catalogue._examined then
					return 'На боковой стенке видна полустерстая литера \"С\"';
				else
					return 'На боковой стенке видна полустерстая литера \"С\". Однако полки сломаны, и если книга где-то и завалялась, то только наверху.';
				end
			else
				return 'Очень хочется надеяться, что это именно тот труд, который мне нужен.';
			end
		else
			return 'На боковой стенке видна полустерстая литера \"С\"';
		end
	end,
	used = function (s,w)
		if catalogue._examined then
			if not s._pulled then
				if w == sp_anim and sp_anim._state == 'rope' then
					s._pulled = true;
					set_sound('snd/animate.ogg');
					sp_anim._state = nil;
					return 'Я забрасываю импровизированное лассо на полку, и со второй попытки вытягиваю на край стеллажа какой-то пыльный талмуд!';
				elseif w == sp_light then
					return 'Светляк немного разгоняет тени наверху, но полки высоко, и мне все равно ничего не видно.';
				elseif w == sp_tele then
					return 'Чтобы воздействовать на какой-либо предмет с расстояния, мне надо его видеть.';
				end
			elseif not reading._placed then
				if w == sp_tele then
					if sp_tele._state == 'book' then
						return 'От того, что она лежит наверху, толку мало.';
					else
						s._inplace = false;
						sp_tele._state = 'book';
						set_sound('snd/telek.ogg');
						return 'Сосредоточившись, чтобы не уронить талмуд на себя, я медленно поднимаю его с полки...';
					end
				end
			end
		end
	end,
}

rope = obj {
	nam = 'веревки',
	dsc = 'С потолка по всему помещению свисают {веревки} непонятного назначения.',
	act = 'Я не мастак лазить по канатам, да и допрыгнуть до них не так-то просто.',
	used = function (s,w)
		if w == sp_anim then
			if sp_anim._state == nil then
				if not shelf._pulled and catalogue._examined then
					sp_anim._state = 'rope';
					sp_anim._active = 0;
					set_sound('snd/animate.ogg');				
					return 'Веревка, подчиняясь моему контролю, оживает и свивается в петлю навроде лассо.';
				end
			else
				return 'ФС-С-С!';
			end
		elseif w == sp_tele and sp_tele._state == nil then
			return 'Веревки только слегка раскачиваются. Чтобы что-то с ними сделать, нужно более направленное воздействие.';
		end
	end,
}

chest = obj {
	_tried = false,
	_lock_pos = 0,
	nam = 'саркофаг',
	dsc = function ()
		if seen(portal) then
			return 'У дальней стены стоит раскрытый саркофаг.';
		elseif not seen(mirror) then
			return 'У дальней стены стоит огромный железный {саркофаг}, закрытый на вычурный замок.';
		else
			return 'У дальней стены стоит раскрытый саркофаг.';
		end
	end,
	lock = {
		[1] = 'я бы сказал, что это какой-то разомкнутый зигзаг.',
		[2] = 'просто вертикальная черта.',
		[3] = 'наподобие угла, повернутого влево.',
		[4] = 'как будто стрелка, указывающая вверх.',
		[5] = 'вроде половины елки.',
	},
	act = function (s)
		if not visited(runes) then
			return 'На замке изображен какой-то символ. Судя по всему, руны, но до конца не уверен.';
		else
			p ('На замке изображена какая-то руна: '..s.lock[s._lock_pos]);
		end
	end,
	used = function (s,w)
		if not s._tried then
			s._tried = true;
			s._lock_pos = rnd(5);
			return 'Замок вспыхивает и преображается. Видимо, мне все же стоит освежить свои знания.';
		else
			if visited(runes) then
				if s._lock_pos == 1 and w == sp_anim then
					set_sound('snd/animate.ogg');
					mirror:enable();
					here().pic = 'gfx/library2.png';
					return 'Рунический замок исчезает во вспышке света, и створки саркофага распахиваются...';
				elseif s._lock_pos == 2 and w == sp_freeze then
					set_sound('snd/freeze.ogg');
					mirror:enable();
					here().pic = 'gfx/library2.png';
					return 'Рунический замок исчезает во вспышке света, и створки саркофага распахиваются...';
				elseif s._lock_pos == 3 and w == sp_light then
					set_sound('snd/light.ogg');
					mirror:enable();
					here().pic = 'gfx/library2.png';
					return 'Рунический замок исчезает во вспышке света, и створки саркофага распахиваются...';
				elseif s._lock_pos == 4 and w == sp_zap then
					set_sound('snd/zap.ogg');
					mirror:enable();
					here().pic = 'gfx/library2.png';
					return 'Рунический замок исчезает во вспышке света, и створки саркофага распахиваются...';
				elseif s._lock_pos == 5 and w == sp_tele then
					set_sound('snd/telek.ogg');
					mirror:enable();
					here().pic = 'gfx/library2.png';
					return 'Рунический замок исчезает во вспышке света, и створки саркофага распахиваются...';
				else
					s._lock_pos = rnd(5);
					return 'Рунический замок вспыхивает, и символ на нем меняется!';
				end
			else
				if w == sp_anim and sp_anim._state == 'rope' then
					return 'Петлей этот замок не сорвать.';
				elseif w == sp_tele and sp_tele._state == 'book' then
					return 'Чтобы открыть замок, книгу надо использовать иначе, то есть по назначению.';
				else
					return 'Рунический замок вспыхивает, и символ на нем меняется!';
				end
			end
		end
	end,
}

mirror = obj {
	nam = 'зеркало',
	dsc = 'На внутренней его стенке висит {зеркало}!',
	act = 'Зеркало в раме. Скорее всего волшебное, но говорящего лица не видно. Зато через всю поверхность протянулась ужасная трещина.',
	used = function (s,w)
		if w == sp_anim then
			set_sound('snd/animate.ogg');
			walk('d_mirror');
		elseif w == sp_light then
			return 'В волшебном свете внутри зеркала виден длинный, уходящий в темноту коридор. Лучше в такие долго не всматриваться.';
		end
	end,
}:disable();

portal = obj {
	_opened = false,
	nam = 'портал',
	dsc = 'На внутренней его стенке висит зеркало, но вместо стекла в раме воронка {портала}!',
	act = function (s)
		if not s._opened then
			s._opened = true;
			set_sound('snd/success.ogg');
			ways()[2]:enable();
		end
		return 'У меня же нет причин не доверять обиженному на весь мир магическому зеркалу?..';
	end,
}:disable();

runes = room {
	page = 0,
	hideinv = true,
	nam = 'Энциклопедия рун',
	pic = 'gfx/runes_title.png',
	dsc = [[
		ТОМАЗО, Г.О.
		^Энциклопедия рун : хрестоматия по руноведению для выпускников маг. унив. / Г.О. Томазо. -- Изд. XMDCCLVI, испр. и доп. -- "PER ASPERA", 343 Э.Ч.
	]],
	obj = { vobj('pgup', '{След. страница}'), vobj('pgdn', '^{Пред. страница}'):disable() },
	way = { vroom('Закрыть', 'library') },
	exit = function (s)
		p 'Я перелистываю книгу назад к оглавлению.';
		s.page = 0;
		s.pic = 'gfx/runes_title.png';
		objs()[1]:enable();
		objs()[2]:disable();
		return true;
	end,
	act = function (s,w)
		if w == 'pgup' then
			s.page = s.page + 1;
		elseif w == 'pgdn' then
			s.page = s.page - 1;
		end
		if s.page == 1 then
			s.pic = 'gfx/runes_chapter.png';
			objs()[2]:disable();
			return [[
				ГЛАВА XXIV
				^РУНЫ И МАГИЧЕСКОЕ ВОЗДЕЙСТВИЕ
				^...Магический заряд, использованный при написании руны, получает отрицательное значение. При столкновении с подобным зарядом с положительным значением происходит аннигиляция руны. При столкновении с другими зарядами возможны различные реакции...
			]];
		elseif s.page == 2 then
			objs()[2]:enable();
			s.pic = 'gfx/runes_raidho.png';
			return [[
				RAIDHO -- "путешествие"
				^Магические свойства этой руны связаны со способностью двигаться (то есть, действовать) в рамках своих природных ограничений и, соответственно, понимать, в чём эти ограничения состоят. В магических операциях эту руну можно использовать также для того, чтобы подчинить себе обстоятельства, привести их в порядок и взять под волевой контроль.
			]];
		elseif s.page == 3 then
			s.pic = 'gfx/runes_kenaz.png';
			return [[
				KENAZ -- "факел"
				^В магии эта руна служит различным целям. Самое очевидное её применение — для обретения знаний, а точнее — оккультного знания. Эта руна может проявляться как внутренний свет — как факел, освещающий нам путь, когда мы пытаемся проникнуть в неведомые уголки внутреннего мира. Может она стать и оружием, отгоняющим нежелательные влияния, подобно тому, как свет рассеивает тьму.
			]];
		elseif s.page == 4 then
			s.pic = 'gfx/runes_isa.png';
			return [[
				ISA -- "лед"
				^С её помощью можно свести на нет действие любой разрушительной или агрессивной силы, направленной на вас магическими средствами. Сосредоточенная сила этой руны — единственный достойный противовес действию боевых заклятий. Руна отлично служит для самозащиты и отражения любой магической атаки.
			]];
		elseif s.page == 5 then
			s.pic = 'gfx/runes_jera.png';
			return [[
				JERA -- "урожай"
				^Олицетворяет время в целом. Две половинки — символ двух половин года, циклически сменяющих друг друга. Это руна надежды, напоминающая нам о том, что всё пребывает в вечном движении и ничто не остаётся неизменным. Эта руна символизирует плодородие и, прежде всего, богатый урожай. В магии её можно использовать как для ускорения, так и для замедления тех или иных процессов.
			]];
		elseif s.page == 6 then
			s.pic = 'gfx/runes_algiz.png';
			return [[
				ALGIZ -- "щит"
				^В своём прямом положении руна может применяться в магических операциях религиозного характера — например, для воззвания к другим рунам или для расширения сознания в область высших миров. Эта руна — могущественный проводник, канал, по которому энергия богов поступает к человеку, а энергия человека — к богам. Руну можно использовать и в целительстве.
			]];
		elseif s.page == 7 then
			s.pic = 'gfx/runes_tiwaz.png';
			return [[
				TIWAZ -- "воин"
				^Магическое значение этой руны связано с её ролью покровительницы борьбы и противостояния. Она символизирует отвагу и честь — главным образом, честное поведение в бою. Она укрепляет мужество и помогает сделать первый шаг к разрешению сложной ситуации. Иногда она означает, что  стоит предпринять активные действия, и подсказывает, к чему именно следует приложить усилия.
			]];
		elseif s.page == 8 then
			objs()[1]:enable();
			s.pic = 'gfx/runes_ehwaz.png';
			return [[
				EHWAZ -- "лошадь"
				^Позволяет приспособиться к ситуации и извлечь из неё всю возможную пользу. Как магическое средство она привлекает удачу в любое совместное предприятие. В оккультных практиках символизирует астральное или эфирное тело — ту часть нашего «я», которую можно вывести за пределы физического тела. В операциях вредоносной магии служит как руна оборотничества.
			]];
		elseif s.page == 9 then
			objs()[1]:disable();
			s.pic = 'gfx/runes_dagaz.png';
			return [[
				DAGAZ -- "день"
				^В практической магии, в методах четырёх- и восьмичастного колеса, служит для обозначения области вне пространства и времени, или «между мирами». На самом бытовом уровне с помощью этой руны можно скрывать предметы от посторонних глаз.
			]];
		end
	end,
}

d_mirror = dlg {
	hideinv = true,
	nam = 'Магическое зеркало',
	pic = 'gfx/mirror.png',
	obj = {
		[1] = phr ('Свет мой, зеркальце, скажи...', [[-- Губы в бантик завяжи! -- доносится в ответ искаженный помехами голос.^-- Грубоватый ответ.^-- А других у меня и нет, -- вздыхает зеркало. -- Грубость -- единственная реакция на то, что тебя запихивают в самый дальний угол башни в какой-то саркофаг!]], [[pon(2); pon(3)]]),
		[2] = _phr ('То есть, ты местное?', [[-- Покупал еще самый первый хозяин, царствие ему небесное. А вот последнему больше по душе пришелся складной волшебный трельяж... В нем он, видите ли, лучше выглядит. Пф-ф!]], [[if punseen(2,3) then pon(4); end]]),
		[3] = _phr ('Я думал, это из-за трещины.', [[-- Нет, я просто не переношу затрещины. Уж кому-кому, а волшебникам можно было бы уяснить: не уверен в себе до конца, не задавай вопрос "Я ль на свете всех мудрее?"]], [[if punseen(2,3) then pon(4); end]]),
		[4] = _phr ('Есть мысли, как попасть наверх?', [[-- Без крыльев никак, если ты не стерх.^-- А если серьезно?^-- Можешь попросить меня, только не очень слезно.]], [[pon(5); pon(6); pon(7)]]),
		[5] = _phr ('А можно обойтись без этого?', [[-- Извини, но правило есть правило. Не я его составило.]], [[pon(5)]]),
		[6] = _phr ('Свет мой, зеркальце, возьми и меня наверх перенеси...', [[-- Что-то как-то нескладно. Попробуй так, чтобы вышло ладно.]], [[pon(6)]]),
		[7] = _phr ('Зеркало, дружище, отправь меня повыше.', [[-- Что ж, пусть будет так. На безрыбье и рыба рак, -- кивает зеркало. -- Только уговор...^-- Какой?^-- Такой. Не перебивай. Всю жизнь я отвечало на чужие вопросы, теперь пусть кто-то ответит на мои!]], [[return quest(0)]]),
	},
	entered = function ()
		return 'По стеклу пробегает рябь, и на поверхности возникает недовольное, искаженное трещиной лицо. Стало быть, зеркало функционирует, но с цветопередачей у него явно что-то не так.';
	end,
}

question_a = dlg {
	hideinv = true,
	nam = 'Вопрос',
	pic = 'gfx/mirror.png',
	dsc = 'Стал он белым, серым был.^Полуросликов любил.',
	obj = {
		[1] = phr ('Саруман', [[-- А ты точно ученик Магнуса?]], [[pon(1); return quest(1)]]),
		[2] = phr ('Гендальф', [[-- И этот ответ... -- Зеркало пытается изобразить барабанную дробь, но неудачно. -- Правильный!]], [[set_sound('snd/success.ogg'); walk ('correct')]]),
		[3] = phr ('Радагаст', [[-- Мимо!]], [[pon(3); quest(1)]]),
	},
}

question_b = dlg {
	hideinv = true,
	nam = 'Вопрос',
	pic = 'gfx/mirror.png',
	dsc = 'Такого оттенка в палитре нет.^Только волшебник сей видит цвет.',
	obj = {
		[1] = phr ('Сербурмалин', [[-- А вот и нет. Еще одна!]], [[pon(1); return quest(2)]]),
		[2] = phr ('Линкольн', [[-- Не угадал!]], [[pon(2); return quest(2)]]),
		[3] = phr ('Октарин', [[-- И этот ответ... -- Зеркало пытается изобразить барабанную дробь, но неудачно. -- Правильный!]], [[set_sound('snd/success.ogg'); walk ('correct')]]),
	},
}

question_c = dlg {
	hideinv = true,
	nam = 'Вопрос',
	pic = 'gfx/mirror.png',
	dsc = 'Нету прощенья за эти слова.^Их скажешь, и тут же с плеч голова.',
	obj = {
		[1] = phr ('Авада Кедавра', [[-- И этот ответ... -- Зеркало пытается изобразить барабанную дробь, но неудачно. -- Правильный!]], [[set_sound('snd/success.ogg'); walk ('correct')]]),
		[2] = phr ('Сим-салабим', [[-- Ладно, давай другую...]], [[pon(2); return quest(3)]]),
		[3] = phr ('Фокус-покус', [[-- Ты совсем безнадежен!]], [[pon(3); return quest(3)]]),
	},
}

question_d = dlg {
	hideinv = true,
	nam = 'Вопрос',
	pic = 'gfx/mirror.png',
	dsc = 'По зельям она та еще мастерица^и рук зловредных она не боится.',
	obj = {
		[1] = phr ('Цирцея', [[-- Мимо!]], [[pon(1); return quest(4)]]),
		[2] = phr ('Занция', [[-- И этот ответ... -- Зеркало пытается изобразить барабанную дробь, но неудачно. -- Правильный!]], [[set_sound('snd/success.ogg'); walk ('correct')]]),
		[3] = phr ('Моргана', [[-- А вот и нет. Еще одна!]], [[pon(3); return quest(4)]]),
	},
}

question_e = dlg {
	hideinv = true,
	nam = 'Вопрос',
	pic = 'gfx/mirror.png',
	dsc = 'Метлой погоняя, едет в ступе своей -^Этой ведуньей пугают детей.',
	obj = {
		[1] = phr ('Баба-яга', [[-- И этот ответ... -- Зеркало пытается изобразить барабанную дробь, но неудачно. -- Правильный!]], [[set_sound('snd/success.ogg'); walk ('correct')]]),
		[2] = phr ('Арахна', [[-- А ты точно ученик Магнуса?]], [[pon(2); return quest(3)]]),
		[3] = phr ('Галадриэль', [[-- Эх ты, такие вещи надо знать!]], [[pon(3); return quest(3)]]),
	},
}

correct = dlg {
	hideinv = true,
	nam = 'Магическое зеркало',
	pic = 'gfx/mirror.png',
	obj = {
		[1] = phr ('И это значит?..', [[-- Ты победил, и никак иначе! -- торжественно произносит зеркало. Что ж, уговор есть уговор. Открываю портал!]], [[pon(2)]]),
		[2] = _phr ('Спасибо!', [[-- Не за что, было приятно поболтать с кем-либо. Ты заходи, если что...^И с этими словами лицо исчезает.]], [[walk ('library')]])
	},
	exit = function ()
		mirror:disable();
		portal:enable();
		library.pic = 'gfx/library3.png';
		return true;
	end,
}

--attic

attic = room {
	_havekey = false,
	_havepipe = false,
	nam = 'Четвертый этаж. Чердак',
	var { pic = 'gfx/attic0.png' },
	dsc = function (s)
		if not s._havepipe then
			return 'Чердак очень напоминает голову моего наставника, образно выражаясь: просто горы всевозможного хлама, наваленные без всякой системы. Трубка может скрываться где угодно.';
		end
	end,
	obj = { 'artifacts', 'sanctuary', 'laser', 'keys', 'cupboard', 'source', 'box', 'key1' },
	way = { vroom('Открыть ларец', 'inside'):disable() },
	entered = function (s)
		if not visited(s) then
			set_music('mus/attic.ogg');
			return 'Я выхожу из портала и оказываюсь на чердаке. Выше, кажется некуда...';
		elseif s._havepipe then
			ways()[1]:disable();
			return '...Придя в себя, я снова оказываюсь на чердаке. Трубка по-прежнему у меня в руках, и мне по-прежнему необходимо как-то выбраться из башни.^Однако что-то определенно не так...';
		end
	end,
}

artifacts = obj {
	_examined = false,
	nam = 'хлам',
	dsc = 'Большую часть чердака занимают {груды} волшебных и не очень предметов.',
	collection = {
		[1] = 'камень с воткнутым туда клинком. Видно, что камень отчаянно пытались расколоть.',
		[2] = 'грозного вида трехручную тяпку. Интересно, на какой огород она рассчитана?',
		[3] = 'коллекцию насекомых, которую, видимо, начал собирать наставник да забросил. Среди экземпляров только Смертокрыл Ужасающий и Гогач Свигепый.',
		[4] = 'очень мутный шар, в котором будто клубится дым. Заглянув в него, я вижу горящее белое дерево.',
	},
	act = function (s)
		if not disabled(keys) then
			local c = rnd(4);
			p ('Среди всякого хлама я различаю '..s.collection[c]);
		else
			if not s._examined then
				s._examined = true;
				if seen (key1) then
					source:enable();
					box:enable();
					hat:enable();
				end
				return 'Должно же тут быть хоть что-то, что поможет мне поймать ключ...';
			else
				local c = rnd(4);
				p ('Среди всякого хлама я различаю '..s.collection[c]);
			end
		end
	end,
}

sanctuary = obj {
	_visible = false,
	_open = false,
	nam = 'ларец',
	dsc = function (s)
		if s._visible then
			return 'В центре комнаты на изящном пьедестале стоит богато украшенный {ларец}.';
		else
			return 'В центре комнаты установлен изящный {пьедестал}.';
		end
	end,
	act = function (s)
		if not s._visible then
			return 'На вид обыкновенный постамент.';
		elseif laser._on then
			if disabled(laser) then
				laser:enable();
				set_sound('snd/destroy.ogg');
				here().pic = 'gfx/attic2.png';
				return 'Я делаю шаг к ларцу, и вдруг вокруг него возникают лучи защитного поля!';
			else
				return 'Пока ларец защищен полем, даже подходить к нему опасно.';
			end
		elseif attic._havepipe then
			return 'Трубка уже у меня в руках.';
		elseif attic._havekey then
			if not s._open then
				s._open = true;
				ways()[1]:enable();
			end
			return 'Я вставляю ключ в замочную скважину...';
		else
			return 'Ларец заперт на замок.';
		end
	end,
	used = function (s,w)
		if not s._visible then
			if w == sp_light then
				s._visible = true;
				set_sound('snd/light.ogg');
				here().pic = 'gfx/attic1.png';
				return 'Я создаю вспышку магического света, и оказывается, что пьедестал вовсе не так пуст, каким кажется на первый взгляд!';
			end
		elseif seen (laser) then
			if w == sp_tele then
				if sp_tele._state == 'hat' then
					return 'Шляпа мне еще, наверное, пригодится!';
				elseif sp_tele._state == 'cup' then
					set_sound('snd/destroy.ogg');
					sp_tele._state = nil;
					return 'Я подношу чашку к полю, и разряд энергии превращает ее в мелкую крошку.';
				elseif sp_tele._state == 'plate' then
					set_sound('snd/destroy.ogg');
					sp_tele._state = nil;
					return 'Я подношу тарелку к полю, и разряд энергии обращает ее в ничто.';
				elseif sp_tele._state == 'pot' then
					set_sound('snd/destroy.ogg');
					sp_tele._state = nil;
					return 'Я подношу кастрюлю к полю, и энергия поглощает ее.';
				elseif sp_tele._state == 'tray' then
					set_sound('snd/telek.ogg');
					sp_tele._state = nil;
					laser._on = false;
					laser:disable();
					here().pic = 'gfx/attic1.png';
					return 'Я помешаю поднос в поле... Металл начинает светиться под воздействием энергии, но затем разряд отражается от серебряной поверхности, и источник поля замыкает!';
				end
			else
				return 'Пока ларец окружен магическим полем, ни одно заклинание до него не дойдет.';
			end
		end
	end,
}

laser = obj {
	_on = true,
	nam = 'луч',
	dsc = 'Вокруг ларца пульсируют лучи {защитного поля}!',
	act = 'Лучше к ним не приближаться. Это действительно мощная и разрушительная магия.',
	used = function (s,w)
		if w == sp_freeze then
			return 'Поле состоит из энергии чистого разрушения. Заморозкой с ним не справиться.';
		elseif w == sp_anim and sp_anim._state == 'key' then
			return 'Ключ просто испепелит, и тогда мне нипочем не открыть ларец!';
		elseif w == sp_light then
			return 'Нет, это поле вовсе не иллюзия.';
		elseif w == sp_tele then
			if sp_tele._state == 'hat' then
				return 'Шляпа мне еще, наверное, пригодится!';
			elseif sp_tele._state == 'cup' then
				set_sound('snd/destroy.ogg');
				sp_tele._state = nil;
				return 'Я подношу чашку к полю, и разряд энергии превращает ее в мелкую крошку.';
			elseif sp_tele._state == 'plate' then
				set_sound('snd/destroy.ogg');
				sp_tele._state = nil;
				return 'Я подношу тарелку к полю, и разряд энергии обращает ее в ничто.';
			elseif sp_tele._state == 'pot' then
				set_sound('snd/destroy.ogg');
				sp_tele._state = nil;
				return 'Я подношу кастрюлю к полю, и энергия поглощает ее.';
			elseif sp_tele._state == 'tray' then
				set_sound('snd/telek.ogg');
				sp_tele._state = nil;
				s._on = false;
				s:disable();
				here().pic = 'gfx/attic1.png';
				return 'Я помешаю поднос в поле... Металл начинает светиться под воздействием энергии, но затем разряд отражается от серебряной поверхности, и источник поля замыкает!';
			end
		elseif w == sp_zap then
			return 'Поле заряжено очень мощной разрушительной магией. Если совместить два разряда, разнесет не только эту башню, но и парочку соседних.';
		end
	end,
}:disable();

keys = obj {
	nam = 'ключи',
	dsc = 'В стену поодаль вбиты крючки, на которых висит множество {ключей}.',
	act = 'Между мной и ключами целая груда всякого хлама. Так до них не дотянуться.',
	used = function (s,w)
		if w == sp_tele and sp_tele._state == nil then
			set_sound('snd/telek.ogg');
			p 'Едва я потянулся энергетической хваткой к ключам, как все они или растворились, или разлетелись-разбежались кто куда.';
			local k = rnd(1);
			if k == 1 then
				key1:enable();
				p 'Один из ключей взмывает ввысь к потолку!';
			end
			s:disable();
		end
	end,
}

key1 = obj {
	_cold = false,
	_caught = false,
	nam = 'ключ',
	dsc = function (s)
		if not s._caught then
			return 'Под потолком вокруг лампы порхает {ключ}!';
		else
			return 'О его стеклянные стенки бьется {ключ}!';
		end
	end,
	act = function (s)
		if not s._caught then
			return 'Мне до него не допрыгнуть.';
		else
			if not source._covered then
				s._caught = false;
				s._cold = false;
				move(s, 'attic');
				set_sound('snd/wings.ogg');
				return 'Я тянусь за ключом, но тот ловко уворачивается и снова взмывает к потолку.';
			else
				if not s._cold then
					return 'Я слегка приподнимаю шляпу... Ай, жжется!';
				else
					attic._havekey = true;
					source:disable();
					hat:disable();
					box:disable();
					set_sound('snd/success.ogg');
					return 'Я слегка приподнимаю шляпу и быстрым движением хватаю ключ. Теперь-то ты никуда от меня не денешься!';
				end
			end
		end
	end,
	used = function (s,w)
		if w == sp_freeze then
			if not s._caught or source._lit then
				return 'Я пытаюсь заморозить ключ, но тот мгновенно оттаивает от тепла светильника.';
			else
				set_sound('snd/freeze.ogg');
				s._cold = true;
				return 'Я замораживаю лампу вместе с ключом. Теперь его можно спокойно взять в руки!';
			end
		elseif w == sp_anim then
			if not s._caught then
				if sp_anim._state == nil then
					sp_anim._state = 'key';
					sp_anim._active = 0;
					set_sound('snd/animate.ogg');				
					return 'Я подчиняю ключ себе в надежде, что смогу направить его туда, куда мне нужно.';
				else
					return 'ХЛОП-ХЛОП!';
				end
			else
				return 'Пусть сидит в светильнике. Оттуда его забрать гораздо легче.';
			end
		elseif w == sp_tele then
			if not s._caught then
				return 'Несмотря на свой размер, ключ удивительно успешно сопротивляется мне.';
			else
				return 'Оттуда его можно взять руками.';
			end
		elseif w == sp_zap then
			if not s._caught then
				return 'Ключ слишком верткий, чтобы в него можно было прицелиться.';
			else
				return 'Если я разобью лампу, то точно не поймаю ключ еще раз.';
			end
		end
	end,
}:disable();

cupboard = obj {
	_opened = false,
	_shelf = 0,
	nam = 'буфет',
	dsc = 'В углу примостился старинный {буфет} для хранения посуды.',
	dishes = {
		[1] = 'чайный сервиз.',
		[2] = 'стопку тарелок.',
		[3] = 'несколько металлических кастрюль.',
		[4] = 'серебряный поднос. Он хорошо отполирован и даже сверкает.',
	},
	act = function (s)
		if not s._opened then
			s._opened = true;
			s._shelf = rnd(4);
			return 'Я открываю буфет. Там действительно еще осталась кое-какая посуда, только самую малость затянутая паутиной.';
		else
			local d = rnd(4);
			while (d == s._shelf) do
				d = rnd(4);
			end
			s._shelf = d;
			p ('На полках я вижу '..s.dishes[s._shelf]);
		end
	end,
	used = function (s,w)
		if w == sp_tele then
			if s._opened then
				if sp_tele._state ~= 'hat' then
					if laser._on then
						if sp_tele._state == nil then
							p 'Я делаю жест в сторону буфета ';
							if s._shelf == 1 then
								set_sound('snd/telek.ogg');
								sp_tele._state = 'cup';
								p 'и вынимаю оттуда одну из чашек.';
							elseif s._shelf == 2 then
								set_sound('snd/telek.ogg');
								sp_tele._state = 'plate';
								p 'и вынимаю оттуда одну из тарелок.';
							elseif s._shelf == 3 then
								set_sound('snd/telek.ogg');
								sp_tele._state = 'pot';
								p 'и вынимаю оттуда одну кастрюлю.';
							elseif s._shelf == 4 then
								set_sound('snd/telek.ogg');
								sp_tele._state = 'tray';
								p 'и вынимаю оттуда серебряный поднос.';
							end
						else
							set_sound('snd/telek.ogg');
							sp_tele._state = nil;
							p 'Я аккуратно кладу посуду на место.';
						end
					else
						return 'Думаю, можно оставить посуду в покое.';
					end
				else
					return 'Шляпа туда не влезет!';
				end
			end
		end
	end,
}

source = obj {
	_lit = false,
	_covered = false,
	nam = 'светильник',
	dsc = function (s)
		if s._lit then
			return 'Стоящий на сундуке {светильник} излучает мягкий свет.';
		else
			return 'На одном из сундуков стоит пыльный {светильник}.';
		end
	end,
	act = 'Да это же Великий Врагов Испепеляющий и Свет Дарящий... Впрочем, нет -- обыкновенный светильник. Как он сюда попал?',
	used = function (s,w)
		if w == sp_freeze then
			if key1._caught then
				if s._lit then
					return 'Я пытаюсь заморозить лампу вместе с ключом, но та мгновенно оттаивает.';
				else
					set_sound('snd/freeze.ogg');
					key1._cold = true;
					return 'Я замораживаю лампу вместе с ключом. Теперь его можно спокойно взять в руки!';
				end
			end
		elseif w == sp_anim and sp_anim._state == 'key' then
			if s._lit then
				if s._covered then
					return 'Ключ радостно летит к новому источнику света, но не может туда попасть и возвращается к потолку.';
				else
					sp_anim._state = nil;
					set_sound('snd/animate.ogg');
					move('key1', s);
					key1._caught = true;
					return 'Ключ залетает на огонек внутрь светильника. Попался!';
				end
			else
				return 'Ключ, видимо, тянет к свету, так что он отказывается улетать от потолочной лампы.';
			end
		elseif w == sp_light then
			if s._lit then
				return 'Светильник замечательно горит и без всякой магии.';
			else
				return 'Внутри светильника стоит обыкновенная свеча. Ее нужно зажигать другим способом.';
			end
		elseif w == sp_tele then
			if sp_tele._state == nil then
				return 'Если мне нужно будет освещение, то у меня есть магия.';
			elseif sp_tele._state == 'hat' then
				p 'Я напяливаю шляпу на светильник.';
				if s._lit then
					s._lit = false
					p 'Без доступа воздуха огонек гаснет.';
				end
				if key1._caught then
					p 'Ключ, почуяв неладное, пытается вырваться на свободу, но у него не выходит.';
				end
				s._covered = true;
				sp_tele._state = nil;
				set_sound('snd/telek.ogg');
				move('hat', s);
			end
		elseif w == sp_zap then
			if s._lit then
				return 'Думаю, она мне еще пригодится.';
			else
				if s._covered then
					return 'Я не могу пустить искру в светильник, пока на нем шляпа.';
				else
					s._lit = true;
					set_sound('snd/zap.ogg');
					return 'Я посылаю искру в светильник, и свечка внутри вспыхивает, заливая все вокруг мягким светом.';
				end
			end
		end
	end,
}:disable();

box = obj {
	nam = 'ящик',
	dsc = function ()
		if not hat._inplace then
			return 'В другом углу стоит массивный {ящик}.';
		end
	end,
	obj = { 'hat' },
	act = 'Понятия не имею, что там внутри, да и без подручного инструмента не выяснить.',
	used = function (s,w)
		if w == sp_tele then
			if sp_tele._state == nil then
				return 'Пусть стоит где стоит. Незачем его двигать по всему чердаку.';
			elseif sp_tele._state == 'hat' then
				set_sound ('snd/telek.ogg');
				move('hat', 'box');
				sp_tele._state = nil;
				hat._inplace = true;
				return 'Я отпускаю шляпу, и она медленно планирует на ящик.';
			end
		elseif w == sp_zap then
			return 'Ж-жах!.. Видимо, я не первый развлекаюсь подобным образом: на одном из бортов ящика выжжено неприличное слово.';
		end
	end,
}:disable();

hat = obj {
	_inplace = true,
	nam = 'шляпа',
	dsc = function (s)
		if s._inplace then
			return 'В другом углу стоит массивный ящик, на котором лежит пыльная {шляпа}.';
		elseif source._covered then
			return 'Сверху на лампу напялена {шляпа}.';
		end		
	end,
	cry = {
		[1] = '\"КОГТЕВРАН!\"',
		[2] = '\"ГРИФФИНДОР!\"',
		[3] = '\"ПУФФЕНДУЙ!\"',
		[4] = '\"СЛИЗЕРИН!\"',
	},
	act = 'Очень древняя шляпа, как бы не из Эпохи легенд. Складки на ней напоминают морщинистое лицо.',
	used = function (s,w)
		if w == sp_anim and sp_anim._state == nil then
			local c = rnd(4);
			p ('Шляпа вздрагивает и хриплым голосом кричит: '..s.cry[c]);
		elseif w == sp_tele and sp_tele._state == nil then
			set_sound ('snd/telek.ogg');
			sp_tele._state = 'hat';
			p 'Я взмахиваю руками, и шляпа поднимается в воздух.';
			if s._inplace then
				s._inplace = false;
			elseif source._covered then
				source._covered = false;
				if key1._caught then
					key1._caught = false;
					key1._cold = false;
					moveto('key1', 'attic', 5);
					add_sound('snd/wings.ogg');
					p 'Ключ тут же устремляется на свободу и взмывает к потолку!';
				end
			end
		elseif w == sp_zap then
			return 'Думаю, она и так достаточно повидала.';
		end
	end,
}:disable();

inside = room {
	hideinv = true,
	nam = 'Ларец',
	pic = 'gfx/inside.png',
	dsc = [[
		Изнутри ларец смотрится гораздо прозаичнее, чем снаружи. Стенки отделаны простым деревом, а на дне лежит красная шелковая подушечка.
	]],
	obj = { 'pipe' },
	entered = function ()
		return 'Я поворачиваю ключ в замке и осторожно, ожидая еще какого-нибудь сюрприза, откидываю крышку...';
	end,
}

pipe = obj {
	nam = 'трубка',
	dsc = 'На подушечке лежит необычного вида {трубка}: что-то вроде уродливой головы на палочке. Сразу видно, что трубкой долго и активно пользовались: один из выступающих клыков отломан, а мундштук весь в царапинах и изрядно пожеван.',
	act = function ()
		set_sound('snd/success.ogg');
		walk('epiphany');
		return true;
	end,
}

epiphany = room {
	hideinv = true,
	nam = 'Трубка',
	pic = 'gfx/epiphany.png',
	dsc = [[	
		Вот он, момент истины. Надо лишь взять трубку и выбираться из башни... как-нибудь. Я провел здесь достаточно времени.
		^^Я беру трубку в руки и внимательно рассматриваю ее. Стоило мне повернуть ее лицом к себе, как глаза огра загораются потусторонним светом!..
		^^Мир вокруг меня как будто перестает существовать - есть только бесконечный, всепоглощающий свет...
	]],
	obj = { vway('next', '{^Дальше...}', 'attic') },
	entered = function ()
		set_sound('snd/whisper.ogg', 4, 0);
	end,
	exit = function ()
		stop_sound();
		attic._havepipe = true;
		take(sp_quit);
		lifeon('sp_quit');
	end,
}

--teleport

nothing = room {
	nam = 'Пустота между мирами',
	disp = '? ? ?',
	var { pic = 'gfx/nothing0.png' },
	dsc = [[
		В этом месте не действуют привычные мне законы... Где я, Баал побери?!
	]],
	obj = { 'bigvine', 'bigchain', 'bigstone', 'biglamp', 'bigdoor' },
	way = { vroom('Вперед!', 'master'):disable() },
	entered = function ()
		if not visited(s) then
			set_music('mus/nothing.ogg');
			return 'Стоило мне произнести незнакомое слово, носившееся в моей голове, как все вокруг меня исчезло и заполнилось пустотой...';
		else
			return 'О нет! Стоило мне вновь произнести это заклинание, как пустота вокруг меня опять перемешалась!';
		end
	end,
}

bigvine = obj {
	nam = 'лианы',
	dsc = 'Передо мной плотно сплетенный клубок {лиан}.',
	act = 'Они шевелятся и на них колючки. Не буду я их трогать!',
	used = function (s,w)
		if w == sp_anim then
			set_sound('snd/animate.ogg');
			s:disable();
			bigchain:enable();
			here().pic = 'gfx/nothing1.png';
			return 'Я пытаюсь подчинить лианы себе, и они послушно расползаются в никуда!';
		end
	end,
}

bigchain = obj {
	nam = 'цепь',
	dsc = 'За лианами обнаружилась огромная {цепь} с гигантским замком!',
	act = 'Моих сил не хватает, чтобы разомкнуть такие звенья. И ключа у меня нет.',
	used = function (s,w)
		if w == sp_zap then
			set_sound('snd/zap.ogg');
			s:disable();
			bigstone:enable();
			here().pic = 'gfx/nothing2.png';
			return 'Разряд срывается с моих пальцев, и цепь превращается в фейерверк разноцветных искр!';
		else
			s:disable();
			bigvine:enable();
			here().pic = 'gfx/nothing0.png';
			return 'Я творю заклинание, и последние минуты будто проматываются назад на моих глазах... Передо мной снова клубок лиан!';
		end
	end,
}:disable();

bigstone = obj {
	nam = 'камень',
	dsc = 'Цепь, оказывается, охватывала необъятный {камень}!',
	act = 'Это просто камень с полуистертой надписью на непонятном мне языке. Что с ним делать -- ума не приложу.',
	used = function (s,w)
		if w == sp_freeze then
			set_sound('snd/freeze.ogg');
			s:disable();
			biglamp:enable();
			here().pic = 'gfx/nothing3.png';
			return 'Я выдыхаю клуб холодного пара, и камень, заледенев, рассыпается в мелкую крошку.';
		else
			s:disable();
			bigvine:enable();
			here().pic = 'gfx/nothing0.png';
			return 'Я творю заклинание, и последние минуты будто проматываются назад на моих глазах... Передо мной снова клубок лиан!';
		end
	end,
}:disable();

biglamp = obj {
	nam = 'лампа',
	dsc = 'Крошки, оставшиеся от камня, превращаются в огромный {фонарь}!',
	act = 'Он не горит и только слегка раскачивается на несуществующем ветру...',
	used = function (s,w)
		if w == sp_light then
			set_sound('snd/light.ogg');
			s:disable();
			bigdoor:enable();
			here().pic = 'gfx/nothing4.png';
			return 'Лампа загорается, заполняя своим светом все окружающее меня пространство, и я невольно зажмуриваюсь...';
		else
			s:disable();
			bigvine:enable();
			here().pic = 'gfx/nothing0.png';
			return 'Я творю заклинание, и последние минуты будто проматываются назад на моих глазах... Передо мной снова клубок лиан!';
		end
	end,
}:disable();

bigdoor = obj {
	_opened = false,
	nam = 'дверь',
	dsc = function (s)
		if not s._opened then
			return 'Свет лампы разгоняет неестественный мрак, и я вижу перед собой {дверь}!';
		else
			return 'Путь открыт! Нужно выбираться отсюда!';
		end
	end,
	act = 'Это волшебная дверь; она растворяется, стоит к ней подойти!',
	used = function (s,w)
		if w == sp_tele then
			set_sound('snd/telek.ogg');
			s._opened = true;
			ways()[1]:enable();
			here().pic = 'gfx/nothing5.png';
			return 'Пасс рукой - и дверь распахивается мне навстречу. За ней видны знакомые очертания Башни...';
		else
			s:disable();
			bigvine:enable();
			here().pic = 'gfx/nothing0.png';
			return 'Я творю заклинание, и последние минуты будто проматываются назад на моих глазах... Передо мной снова клубок лиан!';
		end
	end,
}:disable();

--finale

master = dlg {
	hideinv = true,
	nam = 'Наставник',
	pic = 'gfx/master.png',
	obj = {
		[1] = phr ('Наставник? Но как это я...', [[-- ...Здесь очутился?^-- Все очень просто, ты захотел этого. А настоящая магия -- это не формулы и взмахи руками, это исполнение желаний.^-- Получается, я мог бы переместиться сразу наверх?^-- Ну да, но путь к знанию долог и тернист. И прошел ты его очень даже достойно.]], [[pon(2); pon(3)]]),
		[2] = _phr ('Вот ваша трубка...', [[-- Какая трубка?.. Ах да, благодарю. Честно говоря, я и не думал, что она здесь. Так что тебе повезло -- двух драконов одним огненным шаром!]], [[if punseen(2,3) then pon(4); end]]),
		[3] = _phr ('То есть это был всего лишь экзамен?', [[-- Да, и ты с ним справился. Что-то ты как-то просто к нему относишься.^-- Никак нет, наставник. Просто голова кругом идет.^-- А, понимаю. У самого так было.]], [[if punseen(2,3) then pon(4); end]]),
		[4] = _phr ('И теперь я могу перемещаться куда угодно?', [[-- Да, конечно. Достаточно всего лишь твоей воли. Но начинать рекомендую с чего-нибудь попроще, не с женского общежития.^На этих словах наставник отводит взгляд и вздыхает.]], [[walk('theend')]]),
	},
	entered = function ()
		set_music('mus/intro.ogg');
		return [[
			-- Вот же ж Вельзевулова бородавка! -- восклицаю я, вываливаясь в обычное пространство.
			^-- Надеюсь, ты это не про меня? -- раздается рядом знакомый голос.
			^Ба! Да это же сам наставник...
		]];
	end,
}

theend = room {
	hideinv = true,
	nam = 'Конец',
	pic = 'gfx/theend.png',
	dsc = [[
		Вместе с наставником мы шагаем в пустоту между мирами...
		^-- Кстати, -- говорит Магнус, - ты не знаешь, кто устроил то безобразие сегодня утром?
		^-- Нет, наставник. Но последним у Вашего шкафа я видел Фальстафа...
	]],
	obj = { vway('next', '{^Дальше...}', 'outro'):disable(), vway('evil', '{^Дальше...}', 'evilend'):disable()  },
	entered = function ()
		if not disabled(black) then
			objs()[2]:enable();
		else
			objs()[1]:enable();
		end
	end,
}

evilend = room {
	hideinv = true,
	nam = 'Конец?..',
	pic = 'gfx/evilend.png',
	dsc = [[	]],
	entered = function ()
		stop_music();
		set_sound('snd/laugh.ogg');
		timer:set(3333);
	end,
	timer = function ()
		timer:stop();
		walk('outro');
	end,
}

outro = room {
	hideinv = true,
	nam = 'Башня-60',
	pic = 'gfx/tower60.png',
	dsc = function ()
		pn (txtc(txtem('Интерактивная новелла на движке INSTEAD')))
		pn (txtc(txtb('^ПОСВЯЩАЕТСЯ:')))
		pn (txtc('"Вечному студенту"^Дмитрию Бибишеву'))
		pn (txtc(txtb('^^Идея:')))
		pn (txtc('Михаил Молчанов'))
		pn (txtc('Павел Павленко'))
		pn (txtc(txtb('^Текст, графика, код:')))
		pn (txtc('Михаил Молчанов'))
		pn (txtc('Павел Павленко'))
		pn (txtc(txtb('^Музыка и звуки:')))
		pn (txtc('Celestial Aeon Project^(с сайта jamendo.com)'))
		pn (txtc('звуки с сайта freesound.org'))
		pn (txtc(txtb('^Бета-тестеры:')))
		pn (txtc('Виктор Бессонов'))
		pn (txtc('Вероника Мещерякова'))
		pn (txtc(txtb('^Благодарность:')))
		pn (txtc('Петру Косых'))
		pn (txtc('Сообществу INSTEAD'))
		pn (txtc('^^'..img('gfx/cave-progz.png')..'^^© Студия Cavemen ProgrammerZ, 2015'))
	end,
	entered = function ()
		set_music('mus/outro.ogg');
	end,
}